import{s as Ed,n as Pd,o as Id}from"../chunks/scheduler.85c25b89.js";import{S as Ud,i as Fd,g as d,s as a,r as g,A as Sd,h as o,f as e,c as n,j as Nd,u as h,x as r,k as Vd,y as zd,a as l,v as s,d as f,t as _,w as m}from"../chunks/index.c9837788.js";import{H as c,E as Rd}from"../chunks/EditOnGithub.b65eee75.js";function Bd(tn){let p,re,de,ge,u,he,w,se,v,en="<li>Add dynamic img size support to models in <code>vision_transformer.py</code>, <code>vision_transformer_hybrid.py</code>, <code>deit.py</code>, and <code>eva.py</code> w/o breaking backward compat.<ul><li>Add <code>dynamic_img_size=True</code> to args at model creation time to allow changing the grid size (interpolate abs and/or ROPE pos embed each forward pass).</li> <li>Add <code>dynamic_img_pad=True</code> to allow image sizes that aren’t divisible by patch size (pad bottom right to patch size each forward pass).</li> <li>Enabling either dynamic mode will break FX tracing unless PatchEmbed module added as leaf.</li> <li>Existing method of resizing position embedding by passing different <code>img_size</code> (interpolate pretrained embed weights once) on creation still works.</li> <li>Existing method of changing <code>patch_size</code> (resize pretrained patch_embed weights once) on creation still works.</li> <li>Example validation cmd <code>python validate.py /imagenet --model vit_base_patch16_224 --amp --amp-dtype bfloat16 --img-size 255 --crop-pct 1.0 --model-kwargs dynamic_img_size=True dyamic_img_pad=True</code></li></ul></li>",fe,b,_e,k,ln='<li>Many new models since last release<ul><li>FastViT - <a href="https://arxiv.org/abs/2303.14189" rel="nofollow">https://arxiv.org/abs/2303.14189</a></li> <li>MobileOne - <a href="https://arxiv.org/abs/2206.04040" rel="nofollow">https://arxiv.org/abs/2206.04040</a></li> <li>InceptionNeXt - <a href="https://arxiv.org/abs/2303.16900" rel="nofollow">https://arxiv.org/abs/2303.16900</a></li> <li>RepGhostNet - <a href="https://arxiv.org/abs/2211.06088" rel="nofollow">https://arxiv.org/abs/2211.06088</a> (thanks <a href="https://github.com/ChengpengChen" rel="nofollow">https://github.com/ChengpengChen</a>)</li> <li>GhostNetV2 - <a href="https://arxiv.org/abs/2211.12905" rel="nofollow">https://arxiv.org/abs/2211.12905</a> (thanks <a href="https://github.com/yehuitang" rel="nofollow">https://github.com/yehuitang</a>)</li> <li>EfficientViT (MSRA) - <a href="https://arxiv.org/abs/2305.07027" rel="nofollow">https://arxiv.org/abs/2305.07027</a> (thanks <a href="https://github.com/seefun" rel="nofollow">https://github.com/seefun</a>)</li> <li>EfficientViT (MIT) - <a href="https://arxiv.org/abs/2205.14756" rel="nofollow">https://arxiv.org/abs/2205.14756</a> (thanks <a href="https://github.com/seefun" rel="nofollow">https://github.com/seefun</a>)</li></ul></li> <li>Add <code>--reparam</code> arg to <code>benchmark.py</code>, <code>onnx_export.py</code>, and <code>validate.py</code> to trigger layer reparameterization / fusion for models with any one of <code>reparameterize()</code>, <code>switch_to_deploy()</code> or <code>fuse()</code><ul><li>Including FastViT, MobileOne, RepGhostNet, EfficientViT (MSRA), RepViT, RepVGG, and LeViT</li></ul></li> <li>Preparing 0.9.6 ‘back to school’ release</li>',me,x,ce,$,an="<li>Swin, MaxViT, CoAtNet, and BEiT models support resizing of image/window size on creation with adaptation of pretrained weights</li> <li>Example validation cmd to test w/ non-square resize <code>python validate.py /imagenet --model swin_base_patch4_window7_224.ms_in22k_ft_in1k --amp --amp-dtype bfloat16 --input-size 3 256 320 --model-kwargs window_size=8,10 img_size=256,320</code></li>",pe,T,ue,y,nn='<li>Add GluonCV weights for HRNet w18_small and w18_small_v2. Converted by <a href="https://github.com/seefun" rel="nofollow">SeeFun</a></li> <li>Fix <code>selecsls*</code> model naming regression</li> <li>Patch and position embedding for ViT/EVA works for bfloat16/float16 weights on load (or activations for on-the-fly resize)</li> <li>v0.9.5 release prep</li>',we,L,ve,M,dn='<li>Added timm trained <code>seresnextaa201d_32x8d.sw_in12k_ft_in1k_384</code> weights (and <code>.sw_in12k</code> pretrain) with 87.3% top-1 on ImageNet-1k, best ImageNet ResNet family model I’m aware of.</li> <li>RepViT model and weights (<a href="https://arxiv.org/abs/2307.09283" rel="nofollow">https://arxiv.org/abs/2307.09283</a>) added by <a href="https://github.com/jameslahm" rel="nofollow">wangao</a></li> <li>I-JEPA ViT feature weights (no classifier) added by <a href="https://github.com/seefun" rel="nofollow">SeeFun</a></li> <li>SAM-ViT (segment anything) feature weights (no classifier) added by <a href="https://github.com/seefun" rel="nofollow">SeeFun</a></li> <li>Add support for alternative feat extraction methods and -ve indices to EfficientNet</li> <li>Add NAdamW optimizer</li> <li>Misc fixes</li>',be,A,ke,C,on="<li><code>timm</code> 0.9 released, transition from 0.8.xdev releases</li>",xe,H,$e,N,rn='<li>Hugging Face Hub downloading is now default, 1132 models on <a href="https://huggingface.co/timm" rel="nofollow">https://huggingface.co/timm</a>, 1163 weights in <code>timm</code></li> <li>DINOv2 vit feature backbone weights added thanks to <a href="https://github.com/leng-yue" rel="nofollow">Leng Yue</a></li> <li>FB MAE vit feature backbone weights added</li> <li>OpenCLIP DataComp-XL L/14 feat backbone weights added</li> <li>MetaFormer (poolformer-v2, caformer, convformer, updated poolformer (v1)) w/ weights added by <a href="https://github.com/fffffgggg54" rel="nofollow">Fredo Guan</a></li> <li>Experimental <code>get_intermediate_layers</code> function on vit/deit models for grabbing hidden states (inspired by DINO impl). This is WIP and may change significantly… feedback welcome.</li> <li>Model creation throws error if <code>pretrained=True</code> and no weights exist (instead of continuing with random initialization)</li> <li>Fix regression with inception / nasnet TF sourced weights with 1001 classes in original classifiers</li> <li>bitsandbytes (<a href="https://github.com/TimDettmers/bitsandbytes" rel="nofollow">https://github.com/TimDettmers/bitsandbytes</a>) optimizers added to factory, use <code>bnb</code> prefix, ie <code>bnbadam8bit</code></li> <li>Misc cleanup and fixes</li> <li>Final testing before switching to a 0.9 and bringing <code>timm</code> out of pre-release state</li>',Te,V,ye,E,gn="<li>97% of <code>timm</code> models uploaded to HF Hub and almost all updated to support multi-weight pretrained configs</li> <li>Minor cleanup and refactoring of another batch of models as multi-weight added. More fused_attn (F.sdpa) and features_only support, and torchscript fixes.</li>",Le,P,Me,I,hn='<li>Gradient accumulation support added to train script and tested (<code>--grad-accum-steps</code>), thanks <a href="https://github.com/voidbag" rel="nofollow">Taeksang Kim</a></li> <li>More weights on HF Hub (cspnet, cait, volo, xcit, tresnet, hardcorenas, densenet, dpn, vovnet, xception_aligned)</li> <li>Added <code>--head-init-scale</code> and <code>--head-init-bias</code> to train.py to scale classiifer head and set fixed bias for fine-tune</li> <li>Remove all InplaceABN (<code>inplace_abn</code>) use, replaced use in tresnet with standard BatchNorm (modified weights accordingly).</li>',Ae,U,Ce,F,sn="<li>Add ONNX export script, validate script, helpers that I’ve had kicking around for along time. Tweak ‘same’ padding for better export w/ recent ONNX + pytorch.</li> <li>Refactor dropout args for vit and vit-like models, separate drop_rate into <code>drop_rate</code> (classifier dropout), <code>proj_drop_rate</code> (block mlp / out projections), <code>pos_drop_rate</code> (position embedding drop), <code>attn_drop_rate</code> (attention dropout). Also add patch dropout (FLIP) to vit and eva models.</li> <li>fused F.scaled_dot_product_attention support to more vit models, add env var (TIMM_FUSED_ATTN) to control, and config interface to enable/disable</li> <li>Add EVA-CLIP backbones w/ image tower weights, all the way up to 4B param ‘enormous’ model, and 336x336 OpenAI ViT mode that was missed.</li>",He,S,Ne,z,fn='<li>ALL ResNet models pushed to Hugging Face Hub with multi-weight support<ul><li>All past <code>timm</code> trained weights added with recipe based tags to differentiate</li> <li>All ResNet strikes back A1/A2/A3 (seed 0) and R50 example B/C1/C2/D weights available</li> <li>Add torchvision v2 recipe weights to existing torchvision originals</li> <li>See comparison table in <a href="https://huggingface.co/timm/seresnextaa101d_32x8d.sw_in12k_ft_in1k_288#model-comparison" rel="nofollow">https://huggingface.co/timm/seresnextaa101d_32x8d.sw_in12k_ft_in1k_288#model-comparison</a></li></ul></li> <li>New ImageNet-12k + ImageNet-1k fine-tunes available for a few anti-aliased ResNet models<ul><li><code>resnetaa50d.sw_in12k_ft_in1k</code> - 81.7 @ 224, 82.6 @ 288</li> <li><code>resnetaa101d.sw_in12k_ft_in1k</code> - 83.5 @ 224, 84.1 @ 288</li> <li><code>seresnextaa101d_32x8d.sw_in12k_ft_in1k</code> - 86.0 @ 224, 86.5 @ 288</li> <li><code>seresnextaa101d_32x8d.sw_in12k_ft_in1k_288</code> - 86.5 @ 288, 86.7 @ 320</li></ul></li>',Ve,R,Ee,B,_n="<li>Add first ConvNext-XXLarge CLIP -&gt; IN-1k fine-tune and IN-12k intermediate fine-tunes for convnext-base/large CLIP models.</li>",Pe,X,mn='<thead><tr><th>model</th> <th>top1</th> <th>top5</th> <th>img_size</th> <th>param_count</th> <th>gmacs</th> <th>macts</th></tr></thead> <tbody><tr><td><a href="https://huggingface.co/timm/convnext_xxlarge.clip_laion2b_soup_ft_in1k" rel="nofollow">convnext_xxlarge.clip_laion2b_soup_ft_in1k</a></td> <td>88.612</td> <td>98.704</td> <td>256</td> <td>846.47</td> <td>198.09</td> <td>124.45</td></tr> <tr><td>convnext_large_mlp.clip_laion2b_soup_ft_in12k_in1k_384</td> <td>88.312</td> <td>98.578</td> <td>384</td> <td>200.13</td> <td>101.11</td> <td>126.74</td></tr> <tr><td>convnext_large_mlp.clip_laion2b_soup_ft_in12k_in1k_320</td> <td>87.968</td> <td>98.47</td> <td>320</td> <td>200.13</td> <td>70.21</td> <td>88.02</td></tr> <tr><td>convnext_base.clip_laion2b_augreg_ft_in12k_in1k_384</td> <td>87.138</td> <td>98.212</td> <td>384</td> <td>88.59</td> <td>45.21</td> <td>84.49</td></tr> <tr><td>convnext_base.clip_laion2b_augreg_ft_in12k_in1k</td> <td>86.344</td> <td>97.97</td> <td>256</td> <td>88.59</td> <td>20.09</td> <td>37.55</td></tr></tbody>',Ie,j,cn='<li>Add EVA-02 MIM pretrained and fine-tuned weights, push to HF hub and update model cards for all EVA models. First model over 90% top-1 (99% top-5)! Check out the original code &amp; weights at <a href="https://github.com/baaivision/EVA" rel="nofollow">https://github.com/baaivision/EVA</a> for more details on their work blending MIM, CLIP w/ many model, dataset, and train recipe tweaks.</li>',Ue,G,pn='<thead><tr><th>model</th> <th>top1</th> <th>top5</th> <th>param_count</th> <th>img_size</th></tr></thead> <tbody><tr><td><a href="https://huggingface.co/timm/eva02_large_patch14_448.mim_m38m_ft_in1k" rel="nofollow">eva02_large_patch14_448.mim_m38m_ft_in22k_in1k</a></td> <td>90.054</td> <td>99.042</td> <td>305.08</td> <td>448</td></tr> <tr><td>eva02_large_patch14_448.mim_in22k_ft_in22k_in1k</td> <td>89.946</td> <td>99.01</td> <td>305.08</td> <td>448</td></tr> <tr><td>eva_giant_patch14_560.m30m_ft_in22k_in1k</td> <td>89.792</td> <td>98.992</td> <td>1014.45</td> <td>560</td></tr> <tr><td>eva02_large_patch14_448.mim_in22k_ft_in1k</td> <td>89.626</td> <td>98.954</td> <td>305.08</td> <td>448</td></tr> <tr><td>eva02_large_patch14_448.mim_m38m_ft_in1k</td> <td>89.57</td> <td>98.918</td> <td>305.08</td> <td>448</td></tr> <tr><td>eva_giant_patch14_336.m30m_ft_in22k_in1k</td> <td>89.56</td> <td>98.956</td> <td>1013.01</td> <td>336</td></tr> <tr><td>eva_giant_patch14_336.clip_ft_in1k</td> <td>89.466</td> <td>98.82</td> <td>1013.01</td> <td>336</td></tr> <tr><td>eva_large_patch14_336.in22k_ft_in22k_in1k</td> <td>89.214</td> <td>98.854</td> <td>304.53</td> <td>336</td></tr> <tr><td>eva_giant_patch14_224.clip_ft_in1k</td> <td>88.882</td> <td>98.678</td> <td>1012.56</td> <td>224</td></tr> <tr><td>eva02_base_patch14_448.mim_in22k_ft_in22k_in1k</td> <td>88.692</td> <td>98.722</td> <td>87.12</td> <td>448</td></tr> <tr><td>eva_large_patch14_336.in22k_ft_in1k</td> <td>88.652</td> <td>98.722</td> <td>304.53</td> <td>336</td></tr> <tr><td>eva_large_patch14_196.in22k_ft_in22k_in1k</td> <td>88.592</td> <td>98.656</td> <td>304.14</td> <td>196</td></tr> <tr><td>eva02_base_patch14_448.mim_in22k_ft_in1k</td> <td>88.23</td> <td>98.564</td> <td>87.12</td> <td>448</td></tr> <tr><td>eva_large_patch14_196.in22k_ft_in1k</td> <td>87.934</td> <td>98.504</td> <td>304.14</td> <td>196</td></tr> <tr><td>eva02_small_patch14_336.mim_in22k_ft_in1k</td> <td>85.74</td> <td>97.614</td> <td>22.13</td> <td>336</td></tr> <tr><td>eva02_tiny_patch14_336.mim_in22k_ft_in1k</td> <td>80.658</td> <td>95.524</td> <td>5.76</td> <td>336</td></tr></tbody>',Fe,O,un="<li>Multi-weight and HF hub for DeiT and MLP-Mixer based models</li>",Se,D,ze,J,wn='<li>More weights pushed to HF hub along with multi-weight support, including: <code>regnet.py</code>, <code>rexnet.py</code>, <code>byobnet.py</code>, <code>resnetv2.py</code>, <code>swin_transformer.py</code>, <code>swin_transformer_v2.py</code>, <code>swin_transformer_v2_cr.py</code></li> <li>Swin Transformer models support feature extraction (NCHW feat maps for <code>swinv2_cr_*</code>, and NHWC for all others) and spatial embedding outputs.</li> <li>FocalNet (from <a href="https://github.com/microsoft/FocalNet" rel="nofollow">https://github.com/microsoft/FocalNet</a>) models and weights added with significant refactoring, feature extraction, no fixed resolution / sizing constraint</li> <li>RegNet weights increased with HF hub push, SWAG, SEER, and torchvision v2 weights. SEER is pretty poor wrt to performance for model size, but possibly useful.</li> <li>More ImageNet-12k pretrained and 1k fine-tuned <code>timm</code> weights:<ul><li><code>rexnetr_200.sw_in12k_ft_in1k</code> - 82.6 @ 224, 83.2 @ 288</li> <li><code>rexnetr_300.sw_in12k_ft_in1k</code> - 84.0 @ 224, 84.5 @ 288</li> <li><code>regnety_120.sw_in12k_ft_in1k</code> - 85.0 @ 224, 85.4 @ 288</li> <li><code>regnety_160.lion_in12k_ft_in1k</code> - 85.6 @ 224, 86.0 @ 288</li> <li><code>regnety_160.sw_in12k_ft_in1k</code> - 85.6 @ 224, 86.0 @ 288  (compare to SWAG PT + 1k FT this is same BUT much lower res, blows SEER FT away)</li></ul></li> <li>Model name deprecation + remapping functionality added (a milestone for bringing 0.8.x out of pre-release). Mappings being added…</li> <li>Minor bug fixes and improvements.</li>',Re,q,Be,W,vn='<li>Add ConvNeXt-XXLarge CLIP pretrained image tower weights for fine-tune &amp; features (fine-tuning TBD) — see <a href="https://huggingface.co/laion/CLIP-convnext_xxlarge-laion2B-s34B-b82K-augreg-soup" rel="nofollow">model card</a></li> <li>Update <code>convnext_xxlarge</code> default LayerNorm eps to 1e-5 (for CLIP weights, improved stability)</li> <li>0.8.15dev0</li>',Xe,Y,je,K,bn="<li>Add 320x320 <code>convnext_large_mlp.clip_laion2b_ft_320</code> and <code>convnext_lage_mlp.clip_laion2b_ft_soup_320</code> CLIP image tower weights for features &amp; fine-tune</li> <li>0.8.13dev0 pypi release for latest changes w/ move to huggingface org</li>",Ge,Q,Oe,Z,kn='<li><code>safetensor</code> checkpoint support added</li> <li>Add ideas from ‘Scaling Vision Transformers to 22 B. Params’ (<a href="https://arxiv.org/abs/2302.05442" rel="nofollow">https://arxiv.org/abs/2302.05442</a>) — qk norm, RmsNorm, parallel block</li> <li>Add F.scaled<em>dot_product_attention support (PyTorch 2.0 only) to `vit</em><em><code>, </code>vit_relpos</em><code>, </code>coatnet<code>/</code>maxxvit` (to start)</li> <li>Lion optimizer (w/ multi-tensor option) added (<a href="https://arxiv.org/abs/2302.06675" rel="nofollow">https://arxiv.org/abs/2302.06675</a>)</li> <li>gradient checkpointing works with <code>features_only=True</code></li>',De,tt,Je,it,xn='<li>New inference benchmark numbers added in <a href="results/">results</a> folder.</li> <li>Add convnext LAION CLIP trained weights and initial set of in1k fine-tunes<ul><li><code>convnext_base.clip_laion2b_augreg_ft_in1k</code> - 86.2% @ 256x256</li> <li><code>convnext_base.clip_laiona_augreg_ft_in1k_384</code> - 86.5% @ 384x384</li> <li><code>convnext_large_mlp.clip_laion2b_augreg_ft_in1k</code> - 87.3% @ 256x256</li> <li><code>convnext_large_mlp.clip_laion2b_augreg_ft_in1k_384</code> - 87.9% @ 384x384</li></ul></li> <li>Add DaViT models. Supports <code>features_only=True</code>. Adapted from <a href="https://github.com/dingmyu/davit" rel="nofollow">https://github.com/dingmyu/davit</a> by <a href="https://github.com/fffffgggg54" rel="nofollow">Fredo</a>.</li> <li>Use a common NormMlpClassifierHead across MaxViT, ConvNeXt, DaViT</li> <li>Add EfficientFormer-V2 model, update EfficientFormer, and refactor LeViT (closely related architectures). Weights on HF hub.<ul><li>New EfficientFormer-V2 arch, significant refactor from original at (<a href="https://github.com/snap-research/EfficientFormer" rel="nofollow">https://github.com/snap-research/EfficientFormer</a>). Supports <code>features_only=True</code>.</li> <li>Minor updates to EfficientFormer.</li> <li>Refactor LeViT models to stages, add <code>features_only=True</code> support to new <code>conv</code> variants, weight remap required.</li></ul></li> <li>Move ImageNet meta-data (synsets, indices) from <code>/results</code> to <a href="timm/data/_info/"><code>timm/data/_info</code></a>.</li> <li>Add ImageNetInfo / DatasetInfo classes to provide labelling for various ImageNet classifier layouts in <code>timm</code><ul><li>Update <code>inference.py</code> to use, try: <code>python inference.py /folder/to/images --model convnext_small.in12k --label-type detail --topk 5</code></li></ul></li> <li>Ready for 0.8.10 pypi pre-release (final testing).</li>',qe,et,We,lt,$n="<li><p>Add two convnext 12k -&gt; 1k fine-tunes at 384x384</p> <ul><li><code>convnext_tiny.in12k_ft_in1k_384</code> - 85.1 @ 384</li> <li><code>convnext_small.in12k_ft_in1k_384</code> - 86.2 @ 384</li></ul></li> <li><p>Push all MaxxViT weights to HF hub, and add new ImageNet-12k -&gt; 1k fine-tunes for <code>rw</code> base MaxViT and CoAtNet 1/2 models</p></li>",Ye,at,Tn='<thead><tr><th>model</th> <th align="right">top1</th> <th align="right">top5</th> <th align="right">samples / sec</th> <th align="right">Params (M)</th> <th align="right">GMAC</th> <th align="right">Act (M)</th></tr></thead> <tbody><tr><td><a href="https://huggingface.co/timm/maxvit_xlarge_tf_512.in21k_ft_in1k" rel="nofollow">maxvit_xlarge_tf_512.in21k_ft_in1k</a></td> <td align="right">88.53</td> <td align="right">98.64</td> <td align="right">21.76</td> <td align="right">475.77</td> <td align="right">534.14</td> <td align="right">1413.22</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_xlarge_tf_384.in21k_ft_in1k" rel="nofollow">maxvit_xlarge_tf_384.in21k_ft_in1k</a></td> <td align="right">88.32</td> <td align="right">98.54</td> <td align="right">42.53</td> <td align="right">475.32</td> <td align="right">292.78</td> <td align="right">668.76</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_base_tf_512.in21k_ft_in1k" rel="nofollow">maxvit_base_tf_512.in21k_ft_in1k</a></td> <td align="right">88.20</td> <td align="right">98.53</td> <td align="right">50.87</td> <td align="right">119.88</td> <td align="right">138.02</td> <td align="right">703.99</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_large_tf_512.in21k_ft_in1k" rel="nofollow">maxvit_large_tf_512.in21k_ft_in1k</a></td> <td align="right">88.04</td> <td align="right">98.40</td> <td align="right">36.42</td> <td align="right">212.33</td> <td align="right">244.75</td> <td align="right">942.15</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_large_tf_384.in21k_ft_in1k" rel="nofollow">maxvit_large_tf_384.in21k_ft_in1k</a></td> <td align="right">87.98</td> <td align="right">98.56</td> <td align="right">71.75</td> <td align="right">212.03</td> <td align="right">132.55</td> <td align="right">445.84</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_base_tf_384.in21k_ft_in1k" rel="nofollow">maxvit_base_tf_384.in21k_ft_in1k</a></td> <td align="right">87.92</td> <td align="right">98.54</td> <td align="right">104.71</td> <td align="right">119.65</td> <td align="right">73.80</td> <td align="right">332.90</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_base_rw_384.sw_in12k_ft_in1k" rel="nofollow">maxvit_rmlp_base_rw_384.sw_in12k_ft_in1k</a></td> <td align="right">87.81</td> <td align="right">98.37</td> <td align="right">106.55</td> <td align="right">116.14</td> <td align="right">70.97</td> <td align="right">318.95</td></tr> <tr><td><a href="https://huggingface.co/timm/maxxvitv2_rmlp_base_rw_384.sw_in12k_ft_in1k" rel="nofollow">maxxvitv2_rmlp_base_rw_384.sw_in12k_ft_in1k</a></td> <td align="right">87.47</td> <td align="right">98.37</td> <td align="right">149.49</td> <td align="right">116.09</td> <td align="right">72.98</td> <td align="right">213.74</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_2_rw_384.sw_in12k_ft_in1k" rel="nofollow">coatnet_rmlp_2_rw_384.sw_in12k_ft_in1k</a></td> <td align="right">87.39</td> <td align="right">98.31</td> <td align="right">160.80</td> <td align="right">73.88</td> <td align="right">47.69</td> <td align="right">209.43</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_base_rw_224.sw_in12k_ft_in1k" rel="nofollow">maxvit_rmlp_base_rw_224.sw_in12k_ft_in1k</a></td> <td align="right">86.89</td> <td align="right">98.02</td> <td align="right">375.86</td> <td align="right">116.14</td> <td align="right">23.15</td> <td align="right">92.64</td></tr> <tr><td><a href="https://huggingface.co/timm/maxxvitv2_rmlp_base_rw_224.sw_in12k_ft_in1k" rel="nofollow">maxxvitv2_rmlp_base_rw_224.sw_in12k_ft_in1k</a></td> <td align="right">86.64</td> <td align="right">98.02</td> <td align="right">501.03</td> <td align="right">116.09</td> <td align="right">24.20</td> <td align="right">62.77</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_base_tf_512.in1k" rel="nofollow">maxvit_base_tf_512.in1k</a></td> <td align="right">86.60</td> <td align="right">97.92</td> <td align="right">50.75</td> <td align="right">119.88</td> <td align="right">138.02</td> <td align="right">703.99</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_2_rw_224.sw_in12k_ft_in1k" rel="nofollow">coatnet_2_rw_224.sw_in12k_ft_in1k</a></td> <td align="right">86.57</td> <td align="right">97.89</td> <td align="right">631.88</td> <td align="right">73.87</td> <td align="right">15.09</td> <td align="right">49.22</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_large_tf_512.in1k" rel="nofollow">maxvit_large_tf_512.in1k</a></td> <td align="right">86.52</td> <td align="right">97.88</td> <td align="right">36.04</td> <td align="right">212.33</td> <td align="right">244.75</td> <td align="right">942.15</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_2_rw_224.sw_in12k_ft_in1k" rel="nofollow">coatnet_rmlp_2_rw_224.sw_in12k_ft_in1k</a></td> <td align="right">86.49</td> <td align="right">97.90</td> <td align="right">620.58</td> <td align="right">73.88</td> <td align="right">15.18</td> <td align="right">54.78</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_base_tf_384.in1k" rel="nofollow">maxvit_base_tf_384.in1k</a></td> <td align="right">86.29</td> <td align="right">97.80</td> <td align="right">101.09</td> <td align="right">119.65</td> <td align="right">73.80</td> <td align="right">332.90</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_large_tf_384.in1k" rel="nofollow">maxvit_large_tf_384.in1k</a></td> <td align="right">86.23</td> <td align="right">97.69</td> <td align="right">70.56</td> <td align="right">212.03</td> <td align="right">132.55</td> <td align="right">445.84</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_small_tf_512.in1k" rel="nofollow">maxvit_small_tf_512.in1k</a></td> <td align="right">86.10</td> <td align="right">97.76</td> <td align="right">88.63</td> <td align="right">69.13</td> <td align="right">67.26</td> <td align="right">383.77</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_tiny_tf_512.in1k" rel="nofollow">maxvit_tiny_tf_512.in1k</a></td> <td align="right">85.67</td> <td align="right">97.58</td> <td align="right">144.25</td> <td align="right">31.05</td> <td align="right">33.49</td> <td align="right">257.59</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_small_tf_384.in1k" rel="nofollow">maxvit_small_tf_384.in1k</a></td> <td align="right">85.54</td> <td align="right">97.46</td> <td align="right">188.35</td> <td align="right">69.02</td> <td align="right">35.87</td> <td align="right">183.65</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_tiny_tf_384.in1k" rel="nofollow">maxvit_tiny_tf_384.in1k</a></td> <td align="right">85.11</td> <td align="right">97.38</td> <td align="right">293.46</td> <td align="right">30.98</td> <td align="right">17.53</td> <td align="right">123.42</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_large_tf_224.in1k" rel="nofollow">maxvit_large_tf_224.in1k</a></td> <td align="right">84.93</td> <td align="right">96.97</td> <td align="right">247.71</td> <td align="right">211.79</td> <td align="right">43.68</td> <td align="right">127.35</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_1_rw2_224.sw_in12k_ft_in1k" rel="nofollow">coatnet_rmlp_1_rw2_224.sw_in12k_ft_in1k</a></td> <td align="right">84.90</td> <td align="right">96.96</td> <td align="right">1025.45</td> <td align="right">41.72</td> <td align="right">8.11</td> <td align="right">40.13</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_base_tf_224.in1k" rel="nofollow">maxvit_base_tf_224.in1k</a></td> <td align="right">84.85</td> <td align="right">96.99</td> <td align="right">358.25</td> <td align="right">119.47</td> <td align="right">24.04</td> <td align="right">95.01</td></tr> <tr><td><a href="https://huggingface.co/timm/maxxvit_rmlp_small_rw_256.sw_in1k" rel="nofollow">maxxvit_rmlp_small_rw_256.sw_in1k</a></td> <td align="right">84.63</td> <td align="right">97.06</td> <td align="right">575.53</td> <td align="right">66.01</td> <td align="right">14.67</td> <td align="right">58.38</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_2_rw_224.sw_in1k" rel="nofollow">coatnet_rmlp_2_rw_224.sw_in1k</a></td> <td align="right">84.61</td> <td align="right">96.74</td> <td align="right">625.81</td> <td align="right">73.88</td> <td align="right">15.18</td> <td align="right">54.78</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_small_rw_224.sw_in1k" rel="nofollow">maxvit_rmlp_small_rw_224.sw_in1k</a></td> <td align="right">84.49</td> <td align="right">96.76</td> <td align="right">693.82</td> <td align="right">64.90</td> <td align="right">10.75</td> <td align="right">49.30</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_small_tf_224.in1k" rel="nofollow">maxvit_small_tf_224.in1k</a></td> <td align="right">84.43</td> <td align="right">96.83</td> <td align="right">647.96</td> <td align="right">68.93</td> <td align="right">11.66</td> <td align="right">53.17</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_tiny_rw_256.sw_in1k" rel="nofollow">maxvit_rmlp_tiny_rw_256.sw_in1k</a></td> <td align="right">84.23</td> <td align="right">96.78</td> <td align="right">807.21</td> <td align="right">29.15</td> <td align="right">6.77</td> <td align="right">46.92</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_1_rw_224.sw_in1k" rel="nofollow">coatnet_1_rw_224.sw_in1k</a></td> <td align="right">83.62</td> <td align="right">96.38</td> <td align="right">989.59</td> <td align="right">41.72</td> <td align="right">8.04</td> <td align="right">34.60</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_tiny_rw_224.sw_in1k" rel="nofollow">maxvit_tiny_rw_224.sw_in1k</a></td> <td align="right">83.50</td> <td align="right">96.50</td> <td align="right">1100.53</td> <td align="right">29.06</td> <td align="right">5.11</td> <td align="right">33.11</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_tiny_tf_224.in1k" rel="nofollow">maxvit_tiny_tf_224.in1k</a></td> <td align="right">83.41</td> <td align="right">96.59</td> <td align="right">1004.94</td> <td align="right">30.92</td> <td align="right">5.60</td> <td align="right">35.78</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_1_rw_224.sw_in1k" rel="nofollow">coatnet_rmlp_1_rw_224.sw_in1k</a></td> <td align="right">83.36</td> <td align="right">96.45</td> <td align="right">1093.03</td> <td align="right">41.69</td> <td align="right">7.85</td> <td align="right">35.47</td></tr> <tr><td><a href="https://huggingface.co/timm/maxxvitv2_nano_rw_256.sw_in1k" rel="nofollow">maxxvitv2_nano_rw_256.sw_in1k</a></td> <td align="right">83.11</td> <td align="right">96.33</td> <td align="right">1276.88</td> <td align="right">23.70</td> <td align="right">6.26</td> <td align="right">23.05</td></tr> <tr><td><a href="https://huggingface.co/timm/maxxvit_rmlp_nano_rw_256.sw_in1k" rel="nofollow">maxxvit_rmlp_nano_rw_256.sw_in1k</a></td> <td align="right">83.03</td> <td align="right">96.34</td> <td align="right">1341.24</td> <td align="right">16.78</td> <td align="right">4.37</td> <td align="right">26.05</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_nano_rw_256.sw_in1k" rel="nofollow">maxvit_rmlp_nano_rw_256.sw_in1k</a></td> <td align="right">82.96</td> <td align="right">96.26</td> <td align="right">1283.24</td> <td align="right">15.50</td> <td align="right">4.47</td> <td align="right">31.92</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_nano_rw_256.sw_in1k" rel="nofollow">maxvit_nano_rw_256.sw_in1k</a></td> <td align="right">82.93</td> <td align="right">96.23</td> <td align="right">1218.17</td> <td align="right">15.45</td> <td align="right">4.46</td> <td align="right">30.28</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_bn_0_rw_224.sw_in1k" rel="nofollow">coatnet_bn_0_rw_224.sw_in1k</a></td> <td align="right">82.39</td> <td align="right">96.19</td> <td align="right">1600.14</td> <td align="right">27.44</td> <td align="right">4.67</td> <td align="right">22.04</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_0_rw_224.sw_in1k" rel="nofollow">coatnet_0_rw_224.sw_in1k</a></td> <td align="right">82.39</td> <td align="right">95.84</td> <td align="right">1831.21</td> <td align="right">27.44</td> <td align="right">4.43</td> <td align="right">18.73</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_rmlp_nano_rw_224.sw_in1k" rel="nofollow">coatnet_rmlp_nano_rw_224.sw_in1k</a></td> <td align="right">82.05</td> <td align="right">95.87</td> <td align="right">2109.09</td> <td align="right">15.15</td> <td align="right">2.62</td> <td align="right">20.34</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnext_nano_rw_224.sw_in1k" rel="nofollow">coatnext_nano_rw_224.sw_in1k</a></td> <td align="right">81.95</td> <td align="right">95.92</td> <td align="right">2525.52</td> <td align="right">14.70</td> <td align="right">2.47</td> <td align="right">12.80</td></tr> <tr><td><a href="https://huggingface.co/timm/coatnet_nano_rw_224.sw_in1k" rel="nofollow">coatnet_nano_rw_224.sw_in1k</a></td> <td align="right">81.70</td> <td align="right">95.64</td> <td align="right">2344.52</td> <td align="right">15.14</td> <td align="right">2.41</td> <td align="right">15.41</td></tr> <tr><td><a href="https://huggingface.co/timm/maxvit_rmlp_pico_rw_256.sw_in1k" rel="nofollow">maxvit_rmlp_pico_rw_256.sw_in1k</a></td> <td align="right">80.53</td> <td align="right">95.21</td> <td align="right">1594.71</td> <td align="right">7.52</td> <td align="right">1.85</td> <td align="right">24.86</td></tr></tbody>',Ke,nt,Qe,dt,yn="<li>Update ConvNeXt ImageNet-12k pretrain series w/ two new fine-tuned weights (and pre FT <code>.in12k</code> tags)<ul><li><code>convnext_nano.in12k_ft_in1k</code> - 82.3 @ 224, 82.9 @ 288  (previously released)</li> <li><code>convnext_tiny.in12k_ft_in1k</code> - 84.2 @ 224, 84.5 @ 288</li> <li><code>convnext_small.in12k_ft_in1k</code> - 85.2 @ 224, 85.3 @ 288</li></ul></li>",Ze,ot,tl,rt,Ln="<li>Finally got around to adding <code>--model-kwargs</code> and <code>--opt-kwargs</code> to scripts to pass through rare args directly to model classes from cmd line<ul><li><code>train.py /imagenet --model resnet50 --amp --model-kwargs output_stride=16 act_layer=silu</code></li> <li><code>train.py /imagenet --model vit_base_patch16_clip_224 --img-size 240 --amp --model-kwargs img_size=240 patch_size=12</code></li></ul></li> <li>Cleanup some popular models to better support arg passthrough / merge with model configs, more to go.</li>",il,gt,el,ht,Mn=`<li>ConvNeXt-V2 models and weights added to existing <code>convnext.py</code><ul><li>Paper: <a href="http://arxiv.org/abs/2301.00808" rel="nofollow">ConvNeXt V2: Co-designing and Scaling ConvNets with Masked Autoencoders</a></li> <li>Reference impl: <a href="https://github.com/facebookresearch/ConvNeXt-V2" rel="nofollow">https://github.com/facebookresearch/ConvNeXt-V2</a> (NOTE: weights currently CC-BY-NC)
@dataclass</li></ul></li>`,ll,st,al,ft,An='<li>Add FlexiViT models and weights from <a href="https://github.com/google-research/big_vision" rel="nofollow">https://github.com/google-research/big_vision</a> (check out paper at <a href="https://arxiv.org/abs/2212.08013" rel="nofollow">https://arxiv.org/abs/2212.08013</a>)<ul><li>NOTE currently resizing is static on model creation, on-the-fly dynamic / train patch size sampling is a WIP</li></ul></li> <li>Many more models updated to multi-weight and downloadable via HF hub now (convnext, efficientnet, mobilenet, vision_transformer*, beit)</li> <li>More model pretrained tag and adjustments, some model names changed (working on deprecation translations, consider main branch DEV branch right now, use 0.6.x for stable use)</li> <li>More ImageNet-12k (subset of 22k) pretrain models popping up:<ul><li><code>efficientnet_b5.in12k_ft_in1k</code> - 85.9 @ 448x448</li> <li><code>vit_medium_patch16_gap_384.in12k_ft_in1k</code> - 85.5 @ 384x384</li> <li><code>vit_medium_patch16_gap_256.in12k_ft_in1k</code> - 84.5 @ 256x256</li> <li><code>convnext_nano.in12k_ft_in1k</code> - 82.9 @ 288x288</li></ul></li>',nl,_t,dl,mt,Cn='<li>Add ‘EVA l’ to <code>vision_transformer.py</code>, MAE style ViT-L/14 MIM pretrain w/ EVA-CLIP targets, FT on ImageNet-1k (w/ ImageNet-22k intermediate for some)<ul><li>original source: <a href="https://github.com/baaivision/EVA" rel="nofollow">https://github.com/baaivision/EVA</a></li></ul></li>',ol,ct,Hn='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">eva_large_patch14_336.in22k_ft_in22k_in1k</td> <td align="right">89.2</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_336.in22k_ft_in1k</td> <td align="right">88.7</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_196.in22k_ft_in22k_in1k</td> <td align="right">88.6</td> <td align="right">304.1</td> <td align="right">61.6</td> <td align="right">63.5</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_196.in22k_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.1</td> <td align="right">61.6</td> <td align="right">63.5</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr></tbody>',rl,pt,gl,ut,Nn='<li>Add ‘EVA g’, BEiT style ViT-g/14 model weights w/ both MIM pretrain and CLIP pretrain to <code>beit.py</code>.<ul><li>original source: <a href="https://github.com/baaivision/EVA" rel="nofollow">https://github.com/baaivision/EVA</a></li> <li>paper: <a href="https://arxiv.org/abs/2211.07636" rel="nofollow">https://arxiv.org/abs/2211.07636</a></li></ul></li>',hl,wt,Vn='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">eva_giant_patch14_560.m30m_ft_in22k_in1k</td> <td align="right">89.8</td> <td align="right">1014.4</td> <td align="right">1906.8</td> <td align="right">2577.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_336.m30m_ft_in22k_in1k</td> <td align="right">89.6</td> <td align="right">1013</td> <td align="right">620.6</td> <td align="right">550.7</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_336.clip_ft_in1k</td> <td align="right">89.4</td> <td align="right">1013</td> <td align="right">620.6</td> <td align="right">550.7</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_224.clip_ft_in1k</td> <td align="right">89.1</td> <td align="right">1012.6</td> <td align="right">267.2</td> <td align="right">192.6</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr></tbody>',sl,vt,fl,bt,En='<li>Pre-release (<code>0.8.0dev0</code>) of multi-weight support (<code>model_arch.pretrained_tag</code>). Install with <code>pip install --pre timm</code><ul><li>vision_transformer, maxvit, convnext are the first three model impl w/ support</li> <li>model names are changing with this (previous _21k, etc. fn will merge), still sorting out deprecation handling</li> <li>bugs are likely, but I need feedback so please try it out</li> <li>if stability is needed, please use 0.6.x pypi releases or clone from <a href="https://github.com/rwightman/pytorch-image-models/tree/0.6.x" rel="nofollow">0.6.x branch</a></li></ul></li> <li>Support for PyTorch 2.0 compile is added in train/validate/inference/benchmark, use <code>--torchcompile</code> argument</li> <li>Inference script allows more control over output, select k for top-class index + prob json, csv or parquet output</li> <li>Add a full set of fine-tuned CLIP image tower weights from both LAION-2B and original OpenAI CLIP models</li>',_l,kt,Pn='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">vit_huge_patch14_clip_336.laion2b_ft_in12k_in1k</td> <td align="right">88.6</td> <td align="right">632.5</td> <td align="right">391</td> <td align="right">407.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_336.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.openai_ft_in12k_in1k</td> <td align="right">88.3</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_huge_patch14_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">632</td> <td align="right">167.4</td> <td align="right">139.4</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.laion2b_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.openai_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">87.9</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.openai_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.laion2b_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_huge_patch14_clip_224.laion2b_ft_in1k</td> <td align="right">87.6</td> <td align="right">632</td> <td align="right">167.4</td> <td align="right">139.4</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.laion2b_ft_in1k</td> <td align="right">87.3</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.laion2b_ft_in12k_in1k</td> <td align="right">87.2</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.openai_ft_in12k_in1k</td> <td align="right">87</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.laion2b_ft_in1k</td> <td align="right">86.6</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.openai_ft_in1k</td> <td align="right">86.2</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">86.2</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.openai_ft_in12k_in1k</td> <td align="right">85.9</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_448.laion2b_ft_in12k_in1k</td> <td align="right">85.8</td> <td align="right">88.3</td> <td align="right">17.9</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_448.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.laion2b_ft_in1k</td> <td align="right">85.5</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_384.laion2b_ft_in12k_in1k</td> <td align="right">85.4</td> <td align="right">88.3</td> <td align="right">13.1</td> <td align="right">16.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_384.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.openai_ft_in1k</td> <td align="right">85.3</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_384.openai_ft_in12k_in1k</td> <td align="right">85.2</td> <td align="right">88.3</td> <td align="right">13.1</td> <td align="right">16.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_384.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">83.3</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.laion2b_ft_in1k</td> <td align="right">82.6</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.openai_ft_in1k</td> <td align="right">81.9</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr></tbody>',ml,xt,In='<li>Port of MaxViT Tensorflow Weights from official impl at <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a><ul><li>There was larger than expected drops for the upscaled 384/512 in21k fine-tune weights, possible detail missing, but the 21k FT did seem sensitive to small preprocessing</li></ul></li>',cl,$t,Un='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">maxvit_xlarge_tf_512.in21k_ft_in1k</td> <td align="right">88.5</td> <td align="right">475.8</td> <td align="right">534.1</td> <td align="right">1413.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_xlarge_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_xlarge_tf_384.in21k_ft_in1k</td> <td align="right">88.3</td> <td align="right">475.3</td> <td align="right">292.8</td> <td align="right">668.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_xlarge_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_512.in21k_ft_in1k</td> <td align="right">88.2</td> <td align="right">119.9</td> <td align="right">138</td> <td align="right">704</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_512.in21k_ft_in1k</td> <td align="right">88</td> <td align="right">212.3</td> <td align="right">244.8</td> <td align="right">942.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_384.in21k_ft_in1k</td> <td align="right">88</td> <td align="right">212</td> <td align="right">132.6</td> <td align="right">445.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_384.in21k_ft_in1k</td> <td align="right">87.9</td> <td align="right">119.6</td> <td align="right">73.8</td> <td align="right">332.9</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_512.in1k</td> <td align="right">86.6</td> <td align="right">119.9</td> <td align="right">138</td> <td align="right">704</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_512.in1k</td> <td align="right">86.5</td> <td align="right">212.3</td> <td align="right">244.8</td> <td align="right">942.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_384.in1k</td> <td align="right">86.3</td> <td align="right">119.6</td> <td align="right">73.8</td> <td align="right">332.9</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_384.in1k</td> <td align="right">86.2</td> <td align="right">212</td> <td align="right">132.6</td> <td align="right">445.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_512.in1k</td> <td align="right">86.1</td> <td align="right">69.1</td> <td align="right">67.3</td> <td align="right">383.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_512.in1k</td> <td align="right">85.7</td> <td align="right">31</td> <td align="right">33.5</td> <td align="right">257.6</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_384.in1k</td> <td align="right">85.5</td> <td align="right">69</td> <td align="right">35.9</td> <td align="right">183.6</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_384.in1k</td> <td align="right">85.1</td> <td align="right">31</td> <td align="right">17.5</td> <td align="right">123.4</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_224.in1k</td> <td align="right">84.9</td> <td align="right">211.8</td> <td align="right">43.7</td> <td align="right">127.4</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_224.in1k</td> <td align="right">84.9</td> <td align="right">119.5</td> <td align="right">24</td> <td align="right">95</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_224.in1k</td> <td align="right">84.4</td> <td align="right">68.9</td> <td align="right">11.7</td> <td align="right">53.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_224.in1k</td> <td align="right">83.4</td> <td align="right">30.9</td> <td align="right">5.6</td> <td align="right">35.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_224.in1k" rel="nofollow">link</a></td></tr></tbody>',pl,Tt,ul,yt,Fn="<li>Train and validation script enhancements</li> <li>Non-GPU (ie CPU) device support</li> <li>SLURM compatibility for train script</li> <li>HF datasets support (via ReaderHfds)</li> <li>TFDS/WDS dataloading improvements (sample padding/wrap for distributed use fixed wrt sample count estimate)</li> <li>in_chans !=3 support for scripts / loader</li> <li>Adan optimizer</li> <li>Can enable per-step LR scheduling via args</li> <li>Dataset ‘parsers’ renamed to ‘readers’, more descriptive of purpose</li> <li>AMP args changed, APEX via <code>--amp-impl apex</code>, bfloat16 supportedf via <code>--amp-dtype bfloat16</code></li> <li>main branch switched to 0.7.x version, 0.6x forked for stable release of weight only adds</li> <li>master -&gt; main branch rename</li>",wl,Lt,vl,Mt,Sn='<li>More weights in <code>maxxvit</code> series, incl first ConvNeXt block based <code>coatnext</code> and <code>maxxvit</code> experiments:<ul><li><code>coatnext_nano_rw_224</code> - 82.0 @ 224 (G) — (uses ConvNeXt conv block, no BatchNorm)</li> <li><code>maxxvit_rmlp_nano_rw_256</code> - 83.0 @ 256, 83.7 @ 320  (G) (uses ConvNeXt conv block, no BN)</li> <li><code>maxvit_rmlp_small_rw_224</code> - 84.5 @ 224, 85.1 @ 320 (G)</li> <li><code>maxxvit_rmlp_small_rw_256</code> - 84.6 @ 256, 84.9 @ 288 (G) — could be trained better, hparams need tuning (uses ConvNeXt block, no BN)</li> <li><code>coatnet_rmlp_2_rw_224</code> - 84.6 @ 224, 85 @ 320  (T)</li> <li>NOTE: official MaxVit weights (in1k) have been released at <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a> — some extra work is needed to port and adapt since my impl was created independently of theirs and has a few small differences + the whole TF same padding fun.</li></ul></li>',bl,At,kl,Ct,zn="<li>LAION-2B CLIP image towers supported as pretrained backbones for fine-tune or features (no classifier)<ul><li>vit_base_patch32_224_clip_laion2b</li> <li>vit_large_patch14_224_clip_laion2b</li> <li>vit_huge_patch14_224_clip_laion2b</li> <li>vit_giant_patch14_224_clip_laion2b</li></ul></li>",xl,Ht,$l,Nt,Rn='<li>Hugging Face <a href="https://huggingface.co/docs/hub/timm" rel="nofollow"><code>timm</code> docs</a> home now exists, look for more here in the future</li> <li>Add BEiT-v2 weights for base and large 224x224 models from <a href="https://github.com/microsoft/unilm/tree/master/beit2" rel="nofollow">https://github.com/microsoft/unilm/tree/master/beit2</a></li> <li>Add more weights in <code>maxxvit</code> series incl a <code>pico</code> (7.5M params, 1.9 GMACs), two <code>tiny</code> variants:<ul><li><code>maxvit_rmlp_pico_rw_256</code> - 80.5 @ 256, 81.3 @ 320  (T)</li> <li><code>maxvit_tiny_rw_224</code> - 83.5 @ 224 (G)</li> <li><code>maxvit_rmlp_tiny_rw_256</code> - 84.2 @ 256, 84.8 @ 320 (T)</li></ul></li>',Tl,Vt,yl,Et,Bn="<li>MaxVit window size scales with img_size by default. Add new RelPosMlp MaxViT weight that leverages this:<ul><li><code>maxvit_rmlp_nano_rw_256</code> - 83.0 @ 256, 83.6 @ 320  (T)</li></ul></li>",Ll,Pt,Ml,It,Xn='<li>CoAtNet (<a href="https://arxiv.org/abs/2106.04803" rel="nofollow">https://arxiv.org/abs/2106.04803</a>) and MaxVit (<a href="https://arxiv.org/abs/2204.01697" rel="nofollow">https://arxiv.org/abs/2204.01697</a>) <code>timm</code> original models<ul><li>both found in <a href="https://github.com/rwightman/pytorch-image-models/blob/master/timm/models/maxxvit.py" rel="nofollow"><code>maxxvit.py</code></a> model def, contains numerous experiments outside scope of original papers</li> <li>an unfinished Tensorflow version from MaxVit authors can be found <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a></li></ul></li> <li>Initial CoAtNet and MaxVit timm pretrained weights (working on more):<ul><li><code>coatnet_nano_rw_224</code> - 81.7 @ 224  (T)</li> <li><code>coatnet_rmlp_nano_rw_224</code> - 82.0 @ 224, 82.8 @ 320 (T)</li> <li><code>coatnet_0_rw_224</code> - 82.4  (T)  — NOTE timm ‘0’ coatnets have 2 more 3rd stage blocks</li> <li><code>coatnet_bn_0_rw_224</code> - 82.4  (T)</li> <li><code>maxvit_nano_rw_256</code> - 82.9 @ 256  (T)</li> <li><code>coatnet_rmlp_1_rw_224</code> - 83.4 @ 224, 84 @ 320  (T)</li> <li><code>coatnet_1_rw_224</code> - 83.6 @ 224 (G)</li> <li>(T) = TPU trained with <code>bits_and_tpu</code> branch training code, (G) = GPU trained</li></ul></li> <li>GCVit (weights adapted from <a href="https://github.com/NVlabs/GCVit" rel="nofollow">https://github.com/NVlabs/GCVit</a>, code 100% <code>timm</code> re-write for license purposes)</li> <li>MViT-V2 (multi-scale vit, adapted from <a href="https://github.com/facebookresearch/mvit" rel="nofollow">https://github.com/facebookresearch/mvit</a>)</li> <li>EfficientFormer (adapted from <a href="https://github.com/snap-research/EfficientFormer" rel="nofollow">https://github.com/snap-research/EfficientFormer</a>)</li> <li>PyramidVisionTransformer-V2 (adapted from <a href="https://github.com/whai362/PVT" rel="nofollow">https://github.com/whai362/PVT</a>)</li> <li>‘Fast Norm’ support for LayerNorm and GroupNorm that avoids float32 upcast w/ AMP (uses APEX LN if available for further boost)</li>',Al,Ut,Cl,Ft,jn="<li>ConvNeXt atto weights added<ul><li><code>convnext_atto</code> - 75.7 @ 224, 77.0 @ 288</li> <li><code>convnext_atto_ols</code> - 75.9  @ 224, 77.2 @ 288</li></ul></li>",Hl,St,Nl,zt,Gn='<li>More custom ConvNeXt smaller model defs with weights<ul><li><code>convnext_femto</code> - 77.5 @ 224, 78.7 @ 288</li> <li><code>convnext_femto_ols</code> - 77.9  @ 224, 78.9 @ 288</li> <li><code>convnext_pico</code> - 79.5 @ 224, 80.4 @ 288</li> <li><code>convnext_pico_ols</code> - 79.5 @ 224, 80.5 @ 288</li> <li><code>convnext_nano_ols</code> - 80.9 @ 224, 81.6 @ 288</li></ul></li> <li>Updated EdgeNeXt to improve ONNX export, add new base variant and weights from original (<a href="https://github.com/mmaaz60/EdgeNeXt" rel="nofollow">https://github.com/mmaaz60/EdgeNeXt</a>)</li>',Vl,Rt,El,Bt,On='<li>Add freshly minted DeiT-III Medium (width=512, depth=12, num_heads=8) model weights. Thanks <a href="https://github.com/TouvronHugo" rel="nofollow">Hugo Touvron</a>!</li>',Pl,Xt,Il,jt,Dn="<li>All runtime benchmark and validation result csv files are finally up-to-date!</li> <li>A few more weights &amp; model defs added:<ul><li><code>darknetaa53</code> -  79.8 @ 256, 80.5 @ 288</li> <li><code>convnext_nano</code> - 80.8 @ 224, 81.5 @ 288</li> <li><code>cs3sedarknet_l</code> - 81.2 @ 256, 81.8 @ 288</li> <li><code>cs3darknet_x</code> - 81.8 @ 256, 82.2 @ 288</li> <li><code>cs3sedarknet_x</code> - 82.2 @ 256, 82.7 @ 288</li> <li><code>cs3edgenet_x</code> - 82.2 @ 256, 82.7 @ 288</li> <li><code>cs3se_edgenet_x</code> - 82.8 @ 256, 83.5 @ 320</li></ul></li> <li><code>cs3*</code> weights above all trained on TPU w/ <code>bits_and_tpu</code> branch. Thanks to TRC program!</li> <li>Add output_stride=8 and 16 support to ConvNeXt (dilation)</li> <li>deit3 models not being able to resize pos_emb fixed</li> <li>Version 0.6.7 PyPi release (/w above bug fixes and new weighs since 0.6.5)</li>",Ul,Gt,Fl,Ot,Jn="More models, more fixes",Sl,Dt,qn='<li>Official research models (w/ weights) added:<ul><li>EdgeNeXt from (<a href="https://github.com/mmaaz60/EdgeNeXt" rel="nofollow">https://github.com/mmaaz60/EdgeNeXt</a>)</li> <li>MobileViT-V2 from (<a href="https://github.com/apple/ml-cvnets" rel="nofollow">https://github.com/apple/ml-cvnets</a>)</li> <li>DeiT III (Revenge of the ViT) from (<a href="https://github.com/facebookresearch/deit" rel="nofollow">https://github.com/facebookresearch/deit</a>)</li></ul></li> <li>My own models:<ul><li>Small <code>ResNet</code> defs added by request with 1 block repeats for both basic and bottleneck (resnet10 and resnet14)</li> <li><code>CspNet</code> refactored with dataclass config, simplified CrossStage3 (<code>cs3</code>) option. These are closer to YOLO-v5+ backbone defs.</li> <li>More relative position vit fiddling. Two <code>srelpos</code> (shared relative position) models trained, and a medium w/ class token.</li> <li>Add an alternate downsample mode to EdgeNeXt and train a <code>small</code> model. Better than original small, but not their new USI trained weights.</li></ul></li> <li>My own model weight results (all ImageNet-1k training)<ul><li><code>resnet10t</code> - 66.5 @ 176, 68.3 @ 224</li> <li><code>resnet14t</code> - 71.3 @ 176, 72.3 @ 224</li> <li><code>resnetaa50</code> - 80.6 @ 224 , 81.6 @ 288</li> <li><code>darknet53</code> -  80.0 @ 256, 80.5 @ 288</li> <li><code>cs3darknet_m</code> - 77.0 @ 256, 77.6 @ 288</li> <li><code>cs3darknet_focus_m</code> - 76.7 @ 256, 77.3 @ 288</li> <li><code>cs3darknet_l</code> - 80.4 @ 256, 80.9 @ 288</li> <li><code>cs3darknet_focus_l</code> - 80.3 @ 256, 80.9 @ 288</li> <li><code>vit_srelpos_small_patch16_224</code> - 81.1 @ 224, 82.1 @ 320</li> <li><code>vit_srelpos_medium_patch16_224</code> - 82.3 @ 224, 83.1 @ 320</li> <li><code>vit_relpos_small_patch16_cls_224</code> - 82.6 @ 224, 83.6 @ 320</li> <li><code>edgnext_small_rw</code> - 79.6 @ 224, 80.4 @ 320</li></ul></li> <li><code>cs3</code>, <code>darknet</code>, and <code>vit_*relpos</code> weights above all trained on TPU thanks to TRC program! Rest trained on overheating GPUs.</li> <li>Hugging Face Hub support fixes verified, demo notebook TBA</li> <li>Pretrained weights / configs can be loaded externally (ie from local disk) w/ support for head adaptation.</li> <li>Add support to change image extensions scanned by <code>timm</code> datasets/readers. See (<a href="https://github.com/rwightman/pytorch-image-models/pull/1274#issuecomment-1178303103" rel="nofollow">https://github.com/rwightman/pytorch-image-models/pull/1274#issuecomment-1178303103</a>)</li> <li>Default ConvNeXt LayerNorm impl to use <code>F.layer_norm(x.permute(0, 2, 3, 1), ...).permute(0, 3, 1, 2)</code> via <code>LayerNorm2d</code> in all cases.<ul><li>a bit slower than previous custom impl on some hardware (ie Ampere w/ CL), but overall fewer regressions across wider HW / PyTorch version ranges.</li> <li>previous impl exists as <code>LayerNormExp2d</code> in <code>models/layers/norm.py</code></li></ul></li> <li>Numerous bug fixes</li> <li>Currently testing for imminent PyPi 0.6.x release</li> <li>LeViT pretraining of larger models still a WIP, they don’t train well / easily without distillation. Time to add distill support (finally)?</li> <li>ImageNet-22k weight training + finetune ongoing, work on multi-weight support (slowly) chugging along (there are a LOT of weights, sigh) …</li>',zl,Jt,Rl,qt,Wn='<li>Official Swin-V2 models and weights added from (<a href="https://github.com/microsoft/Swin-Transformer" rel="nofollow">https://github.com/microsoft/Swin-Transformer</a>). Cleaned up to support torchscript.</li> <li>Some refactoring for existing <code>timm</code> Swin-V2-CR impl, will likely do a bit more to bring parts closer to official and decide whether to merge some aspects.</li> <li>More Vision Transformer relative position / residual post-norm experiments (all trained on TPU thanks to TRC program)<ul><li><code>vit_relpos_small_patch16_224</code> - 81.5 @ 224, 82.5 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_relpos_medium_patch16_rpn_224</code> - 82.3 @ 224, 83.1 @ 320 — rel pos + res-post-norm, no class token, avg pool</li> <li><code>vit_relpos_medium_patch16_224</code> - 82.5 @ 224, 83.3 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_relpos_base_patch16_gapcls_224</code> - 82.8 @ 224, 83.9 @ 320 — rel pos, layer scale, class token, avg pool (by mistake)</li></ul></li> <li>Bring 512 dim, 8-head ‘medium’ ViT model variant back to life (after using in a pre DeiT ‘small’ model for first ViT impl back in 2020)</li> <li>Add ViT relative position support for switching btw existing impl and some additions in official Swin-V2 impl for future trials</li> <li>Sequencer2D impl (<a href="https://arxiv.org/abs/2205.01972" rel="nofollow">https://arxiv.org/abs/2205.01972</a>), added via PR from author (<a href="https://github.com/okojoalg" rel="nofollow">https://github.com/okojoalg</a>)</li>',Bl,Wt,Xl,Yt,Yn="<li>Vision Transformer experiments adding Relative Position (Swin-V2 log-coord) (<code>vision_transformer_relpos.py</code>) and Residual Post-Norm branches (from Swin-V2) (<code>vision_transformer*.py</code>)<ul><li><code>vit_relpos_base_patch32_plus_rpn_256</code> - 79.5 @ 256, 80.6 @ 320 — rel pos + extended width + res-post-norm, no class token, avg pool</li> <li><code>vit_relpos_base_patch16_224</code> - 82.5 @ 224, 83.6 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_base_patch16_rpn_224</code> - 82.3 @ 224 — rel pos + res-post-norm, no class token, avg pool</li></ul></li> <li>Vision Transformer refactor to remove representation layer that was only used in initial vit and rarely used since with newer pretrain (ie <code>How to Train Your ViT</code>)</li> <li><code>vit_*</code> models support removal of class token, use of global average pool, use of fc_norm (ala beit, mae).</li>",jl,Kt,Gl,Qt,Kn='<li><code>timm</code> models are now officially supported in <a href="https://www.fast.ai/" rel="nofollow">fast.ai</a>! Just in time for the new Practical Deep Learning course. <code>timmdocs</code> documentation link updated to <a href="http://timm.fast.ai/" rel="nofollow">timm.fast.ai</a>.</li> <li>Two more model weights added in the TPU trained <a href="https://github.com/rwightman/pytorch-image-models/releases/tag/v0.1-tpu-weights" rel="nofollow">series</a>. Some In22k pretrain still in progress.<ul><li><code>seresnext101d_32x8d</code> - 83.69 @ 224, 84.35 @ 288</li> <li><code>seresnextaa101d_32x8d</code> (anti-aliased w/ AvgPool2d) - 83.85 @ 224, 84.57 @ 288</li></ul></li>',Ol,Zt,Dl,ti,Qn='<li>Add <code>ParallelBlock</code> and <code>LayerScale</code> option to base vit models to support model configs in <a href="https://arxiv.org/abs/2203.09795" rel="nofollow">Three things everyone should know about ViT</a></li> <li><code>convnext_tiny_hnf</code> (head norm first) weights trained with (close to) A2 recipe, 82.2% top-1, could do better with more epochs.</li>',Jl,ii,ql,ei,Zn='<li>Merge <code>norm_norm_norm</code>. <strong>IMPORTANT</strong> this update for a coming 0.6.x release will likely de-stabilize the master branch for a while. Branch <a href="https://github.com/rwightman/pytorch-image-models/tree/0.5.x" rel="nofollow"><code>0.5.x</code></a> or a previous 0.5.x release can be used if stability is required.</li> <li>Significant weights update (all TPU trained) as described in this <a href="https://github.com/rwightman/pytorch-image-models/releases/tag/v0.1-tpu-weights" rel="nofollow">release</a><ul><li><code>regnety_040</code> - 82.3 @ 224, 82.96 @ 288</li> <li><code>regnety_064</code> - 83.0 @ 224, 83.65 @ 288</li> <li><code>regnety_080</code> - 83.17 @ 224, 83.86 @ 288</li> <li><code>regnetv_040</code> - 82.44 @ 224, 83.18 @ 288   (timm pre-act)</li> <li><code>regnetv_064</code> - 83.1 @ 224, 83.71 @ 288   (timm pre-act)</li> <li><code>regnetz_040</code> - 83.67 @ 256, 84.25 @ 320</li> <li><code>regnetz_040h</code> - 83.77 @ 256, 84.5 @ 320 (w/ extra fc in head)</li> <li><code>resnetv2_50d_gn</code> - 80.8 @ 224, 81.96 @ 288 (pre-act GroupNorm)</li> <li><code>resnetv2_50d_evos</code> 80.77 @ 224, 82.04 @ 288 (pre-act EvoNormS)</li> <li><code>regnetz_c16_evos</code>  - 81.9 @ 256, 82.64 @ 320 (EvoNormS)</li> <li><code>regnetz_d8_evos</code>  - 83.42 @ 256, 84.04 @ 320 (EvoNormS)</li> <li><code>xception41p</code> - 82 @ 299   (timm pre-act)</li> <li><code>xception65</code> -  83.17 @ 299</li> <li><code>xception65p</code> -  83.14 @ 299   (timm pre-act)</li> <li><code>resnext101_64x4d</code> - 82.46 @ 224, 83.16 @ 288</li> <li><code>seresnext101_32x8d</code> - 83.57 @ 224, 84.270 @ 288</li> <li><code>resnetrs200</code> - 83.85 @ 256, 84.44 @ 320</li></ul></li> <li>HuggingFace hub support fixed w/ initial groundwork for allowing alternative ‘config sources’ for pretrained model definitions and weights (generic local file / remote url support soon)</li> <li>SwinTransformer-V2 implementation added. Submitted by <a href="https://github.com/ChristophReich1996" rel="nofollow">Christoph Reich</a>. Training experiments and model changes by myself are ongoing so expect compat breaks.</li> <li>Swin-S3 (AutoFormerV2) models / weights added from <a href="https://github.com/microsoft/Cream/tree/main/AutoFormerV2" rel="nofollow">https://github.com/microsoft/Cream/tree/main/AutoFormerV2</a></li> <li>MobileViT models w/ weights adapted from <a href="https://github.com/apple/ml-cvnets" rel="nofollow">https://github.com/apple/ml-cvnets</a></li> <li>PoolFormer models w/ weights adapted from <a href="https://github.com/sail-sg/poolformer" rel="nofollow">https://github.com/sail-sg/poolformer</a></li> <li>VOLO models w/ weights adapted from <a href="https://github.com/sail-sg/volo" rel="nofollow">https://github.com/sail-sg/volo</a></li> <li>Significant work experimenting with non-BatchNorm norm layers such as EvoNorm, FilterResponseNorm, GroupNorm, etc</li> <li>Enhance support for alternate norm + act (‘NormAct’) layers added to a number of models, esp EfficientNet/MobileNetV3, RegNet, and aligned Xception</li> <li>Grouped conv support added to EfficientNet family</li> <li>Add ‘group matching’ API to all models to allow grouping model parameters for application of ‘layer-wise’ LR decay, lr scale added to LR scheduler</li> <li>Gradient checkpointing support added to many models</li> <li><code>forward_head(x, pre_logits=False)</code> fn added to all models to allow separate calls of <code>forward_features</code> + <code>forward_head</code></li> <li>All vision transformer and vision MLP models update to return non-pooled / non-token selected features from <code>foward_features</code>, for consistency with CNN models, token selection or pooling now applied in <code>forward_head</code></li>',Wl,li,Yl,ai,td='<li><a href="https://github.com/Chris-hughes10" rel="nofollow">Chris Hughes</a> posted an exhaustive run through of <code>timm</code> on his blog yesterday. Well worth a read. <a href="https://towardsdatascience.com/getting-started-with-pytorch-image-models-timm-a-practitioners-guide-4e77b4bf9055" rel="nofollow">Getting Started with PyTorch Image Models (timm): A Practitioner’s Guide</a></li> <li>I’m currently prepping to merge the <code>norm_norm_norm</code> branch back to master (ver 0.6.x) in next week or so.<ul><li>The changes are more extensive than usual and may destabilize and break some model API use (aiming for full backwards compat). So, beware <code>pip install git+https://github.com/rwightman/pytorch-image-models</code> installs!</li> <li><code>0.5.x</code> releases and a <code>0.5.x</code> branch will remain stable with a cherry pick or two until dust clears. Recommend sticking to pypi install for a bit if you want stable.</li></ul></li>',Kl,ni,Ql,di,id='<li>Version 0.5.4 w/ release to be pushed to pypi. It’s been a while since last pypi update and riskier changes will be merged to main branch soon…</li> <li>Add ConvNeXT models /w weights from official impl (<a href="https://github.com/facebookresearch/ConvNeXt" rel="nofollow">https://github.com/facebookresearch/ConvNeXt</a>), a few perf tweaks, compatible with timm features</li> <li>Tried training a few small (~1.8-3M param) / mobile optimized models, a few are good so far, more on the way…<ul><li><code>mnasnet_small</code> - 65.6 top-1</li> <li><code>mobilenetv2_050</code> - 65.9</li> <li><code>lcnet_100/075/050</code> - 72.1 / 68.8 / 63.1</li> <li><code>semnasnet_075</code> - 73</li> <li><code>fbnetv3_b/d/g</code> - 79.1 / 79.7 / 82.0</li></ul></li> <li>TinyNet models added by <a href="https://github.com/rsomani95" rel="nofollow">rsomani95</a></li> <li>LCNet added via MobileNetV3 architecture</li>',Zl,oi,ta,ri,ed='<li>ConvNeXt-V2 models and weights added to existing <code>convnext.py</code><ul><li>Paper: <a href="http://arxiv.org/abs/2301.00808" rel="nofollow">ConvNeXt V2: Co-designing and Scaling ConvNets with Masked Autoencoders</a></li> <li>Reference impl: <a href="https://github.com/facebookresearch/ConvNeXt-V2" rel="nofollow">https://github.com/facebookresearch/ConvNeXt-V2</a> (NOTE: weights currently CC-BY-NC)</li></ul></li>',ia,gi,ea,hi,ld='<li>Add FlexiViT models and weights from <a href="https://github.com/google-research/big_vision" rel="nofollow">https://github.com/google-research/big_vision</a> (check out paper at <a href="https://arxiv.org/abs/2212.08013" rel="nofollow">https://arxiv.org/abs/2212.08013</a>)<ul><li>NOTE currently resizing is static on model creation, on-the-fly dynamic / train patch size sampling is a WIP</li></ul></li> <li>Many more models updated to multi-weight and downloadable via HF hub now (convnext, efficientnet, mobilenet, vision_transformer*, beit)</li> <li>More model pretrained tag and adjustments, some model names changed (working on deprecation translations, consider main branch DEV branch right now, use 0.6.x for stable use)</li> <li>More ImageNet-12k (subset of 22k) pretrain models popping up:<ul><li><code>efficientnet_b5.in12k_ft_in1k</code> - 85.9 @ 448x448</li> <li><code>vit_medium_patch16_gap_384.in12k_ft_in1k</code> - 85.5 @ 384x384</li> <li><code>vit_medium_patch16_gap_256.in12k_ft_in1k</code> - 84.5 @ 256x256</li> <li><code>convnext_nano.in12k_ft_in1k</code> - 82.9 @ 288x288</li></ul></li>',la,si,aa,fi,ad='<li>Add ‘EVA l’ to <code>vision_transformer.py</code>, MAE style ViT-L/14 MIM pretrain w/ EVA-CLIP targets, FT on ImageNet-1k (w/ ImageNet-22k intermediate for some)<ul><li>original source: <a href="https://github.com/baaivision/EVA" rel="nofollow">https://github.com/baaivision/EVA</a></li></ul></li>',na,_i,nd='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">eva_large_patch14_336.in22k_ft_in22k_in1k</td> <td align="right">89.2</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_336.in22k_ft_in1k</td> <td align="right">88.7</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_196.in22k_ft_in22k_in1k</td> <td align="right">88.6</td> <td align="right">304.1</td> <td align="right">61.6</td> <td align="right">63.5</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_large_patch14_196.in22k_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.1</td> <td align="right">61.6</td> <td align="right">63.5</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr></tbody>',da,mi,oa,ci,dd='<li>Add ‘EVA g’, BEiT style ViT-g/14 model weights w/ both MIM pretrain and CLIP pretrain to <code>beit.py</code>. <ul><li>original source: <a href="https://github.com/baaivision/EVA" rel="nofollow">https://github.com/baaivision/EVA</a></li> <li>paper: <a href="https://arxiv.org/abs/2211.07636" rel="nofollow">https://arxiv.org/abs/2211.07636</a></li></ul></li>',ra,pi,od='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">eva_giant_patch14_560.m30m_ft_in22k_in1k</td> <td align="right">89.8</td> <td align="right">1014.4</td> <td align="right">1906.8</td> <td align="right">2577.2</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_336.m30m_ft_in22k_in1k</td> <td align="right">89.6</td> <td align="right">1013</td> <td align="right">620.6</td> <td align="right">550.7</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_336.clip_ft_in1k</td> <td align="right">89.4</td> <td align="right">1013</td> <td align="right">620.6</td> <td align="right">550.7</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr> <tr><td align="left">eva_giant_patch14_224.clip_ft_in1k</td> <td align="right">89.1</td> <td align="right">1012.6</td> <td align="right">267.2</td> <td align="right">192.6</td> <td align="left"><a href="https://huggingface.co/BAAI/EVA" rel="nofollow">link</a></td></tr></tbody>',ga,ui,ha,wi,rd='<li>Pre-release (<code>0.8.0dev0</code>) of multi-weight support (<code>model_arch.pretrained_tag</code>). Install with <code>pip install --pre timm</code><ul><li>vision_transformer, maxvit, convnext are the first three model impl w/ support</li> <li>model names are changing with this (previous _21k, etc. fn will merge), still sorting out deprecation handling</li> <li>bugs are likely, but I need feedback so please try it out</li> <li>if stability is needed, please use 0.6.x pypi releases or clone from <a href="https://github.com/rwightman/pytorch-image-models/tree/0.6.x" rel="nofollow">0.6.x branch</a></li></ul></li> <li>Support for PyTorch 2.0 compile is added in train/validate/inference/benchmark, use <code>--torchcompile</code> argument</li> <li>Inference script allows more control over output, select k for top-class index + prob json, csv or parquet output</li> <li>Add a full set of fine-tuned CLIP image tower weights from both LAION-2B and original OpenAI CLIP models</li>',sa,vi,gd='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">vit_huge_patch14_clip_336.laion2b_ft_in12k_in1k</td> <td align="right">88.6</td> <td align="right">632.5</td> <td align="right">391</td> <td align="right">407.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_336.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.openai_ft_in12k_in1k</td> <td align="right">88.3</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_huge_patch14_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">632</td> <td align="right">167.4</td> <td align="right">139.4</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.laion2b_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.openai_ft_in12k_in1k</td> <td align="right">88.2</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">87.9</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.openai_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_336.laion2b_ft_in1k</td> <td align="right">87.9</td> <td align="right">304.5</td> <td align="right">191.1</td> <td align="right">270.2</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_336.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_huge_patch14_clip_224.laion2b_ft_in1k</td> <td align="right">87.6</td> <td align="right">632</td> <td align="right">167.4</td> <td align="right">139.4</td> <td align="left"><a href="https://huggingface.co/timm/vit_huge_patch14_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_large_patch14_clip_224.laion2b_ft_in1k</td> <td align="right">87.3</td> <td align="right">304.2</td> <td align="right">81.1</td> <td align="right">88.8</td> <td align="left"><a href="https://huggingface.co/timm/vit_large_patch14_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.laion2b_ft_in12k_in1k</td> <td align="right">87.2</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.openai_ft_in12k_in1k</td> <td align="right">87</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.laion2b_ft_in1k</td> <td align="right">86.6</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_384.openai_ft_in1k</td> <td align="right">86.2</td> <td align="right">86.9</td> <td align="right">55.5</td> <td align="right">101.6</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_384.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">86.2</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.openai_ft_in12k_in1k</td> <td align="right">85.9</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_448.laion2b_ft_in12k_in1k</td> <td align="right">85.8</td> <td align="right">88.3</td> <td align="right">17.9</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_448.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.laion2b_ft_in1k</td> <td align="right">85.5</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_384.laion2b_ft_in12k_in1k</td> <td align="right">85.4</td> <td align="right">88.3</td> <td align="right">13.1</td> <td align="right">16.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_384.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch16_clip_224.openai_ft_in1k</td> <td align="right">85.3</td> <td align="right">86.6</td> <td align="right">17.6</td> <td align="right">23.9</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch16_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_384.openai_ft_in12k_in1k</td> <td align="right">85.2</td> <td align="right">88.3</td> <td align="right">13.1</td> <td align="right">16.5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_384.openai_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.laion2b_ft_in12k_in1k</td> <td align="right">83.3</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.laion2b_ft_in12k_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.laion2b_ft_in1k</td> <td align="right">82.6</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.laion2b_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">vit_base_patch32_clip_224.openai_ft_in1k</td> <td align="right">81.9</td> <td align="right">88.2</td> <td align="right">4.4</td> <td align="right">5</td> <td align="left"><a href="https://huggingface.co/timm/vit_base_patch32_clip_224.openai_ft_in1k" rel="nofollow">link</a></td></tr></tbody>',fa,bi,hd='<li>Port of MaxViT Tensorflow Weights from official impl at <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a><ul><li>There was larger than expected drops for the upscaled 384/512 in21k fine-tune weights, possible detail missing, but the 21k FT did seem sensitive to small preprocessing</li></ul></li>',_a,ki,sd='<thead><tr><th align="left">model</th> <th align="right">top1</th> <th align="right">param_count</th> <th align="right">gmac</th> <th align="right">macts</th> <th align="left">hub</th></tr></thead> <tbody><tr><td align="left">maxvit_xlarge_tf_512.in21k_ft_in1k</td> <td align="right">88.5</td> <td align="right">475.8</td> <td align="right">534.1</td> <td align="right">1413.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_xlarge_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_xlarge_tf_384.in21k_ft_in1k</td> <td align="right">88.3</td> <td align="right">475.3</td> <td align="right">292.8</td> <td align="right">668.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_xlarge_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_512.in21k_ft_in1k</td> <td align="right">88.2</td> <td align="right">119.9</td> <td align="right">138</td> <td align="right">704</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_512.in21k_ft_in1k</td> <td align="right">88</td> <td align="right">212.3</td> <td align="right">244.8</td> <td align="right">942.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_512.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_384.in21k_ft_in1k</td> <td align="right">88</td> <td align="right">212</td> <td align="right">132.6</td> <td align="right">445.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_384.in21k_ft_in1k</td> <td align="right">87.9</td> <td align="right">119.6</td> <td align="right">73.8</td> <td align="right">332.9</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_384.in21k_ft_in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_512.in1k</td> <td align="right">86.6</td> <td align="right">119.9</td> <td align="right">138</td> <td align="right">704</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_512.in1k</td> <td align="right">86.5</td> <td align="right">212.3</td> <td align="right">244.8</td> <td align="right">942.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_384.in1k</td> <td align="right">86.3</td> <td align="right">119.6</td> <td align="right">73.8</td> <td align="right">332.9</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_384.in1k</td> <td align="right">86.2</td> <td align="right">212</td> <td align="right">132.6</td> <td align="right">445.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_512.in1k</td> <td align="right">86.1</td> <td align="right">69.1</td> <td align="right">67.3</td> <td align="right">383.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_512.in1k</td> <td align="right">85.7</td> <td align="right">31</td> <td align="right">33.5</td> <td align="right">257.6</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_512.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_384.in1k</td> <td align="right">85.5</td> <td align="right">69</td> <td align="right">35.9</td> <td align="right">183.6</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_384.in1k</td> <td align="right">85.1</td> <td align="right">31</td> <td align="right">17.5</td> <td align="right">123.4</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_384.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_large_tf_224.in1k</td> <td align="right">84.9</td> <td align="right">211.8</td> <td align="right">43.7</td> <td align="right">127.4</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_large_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_base_tf_224.in1k</td> <td align="right">84.9</td> <td align="right">119.5</td> <td align="right">24</td> <td align="right">95</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_base_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_small_tf_224.in1k</td> <td align="right">84.4</td> <td align="right">68.9</td> <td align="right">11.7</td> <td align="right">53.2</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_small_tf_224.in1k" rel="nofollow">link</a></td></tr> <tr><td align="left">maxvit_tiny_tf_224.in1k</td> <td align="right">83.4</td> <td align="right">30.9</td> <td align="right">5.6</td> <td align="right">35.8</td> <td align="left"><a href="https://huggingface.co/timm/maxvit_tiny_tf_224.in1k" rel="nofollow">link</a></td></tr></tbody>',ma,xi,ca,$i,fd="<li>Train and validation script enhancements</li> <li>Non-GPU (ie CPU) device support</li> <li>SLURM compatibility for train script</li> <li>HF datasets support (via ReaderHfds)</li> <li>TFDS/WDS dataloading improvements (sample padding/wrap for distributed use fixed wrt sample count estimate)</li> <li>in_chans !=3 support for scripts / loader</li> <li>Adan optimizer</li> <li>Can enable per-step LR scheduling via args</li> <li>Dataset ‘parsers’ renamed to ‘readers’, more descriptive of purpose</li> <li>AMP args changed, APEX via <code>--amp-impl apex</code>, bfloat16 supportedf via <code>--amp-dtype bfloat16</code></li> <li>main branch switched to 0.7.x version, 0.6x forked for stable release of weight only adds</li> <li>master -&gt; main branch rename</li>",pa,Ti,ua,yi,_d='<li>More weights in <code>maxxvit</code> series, incl first ConvNeXt block based <code>coatnext</code> and <code>maxxvit</code> experiments:<ul><li><code>coatnext_nano_rw_224</code> - 82.0 @ 224 (G) — (uses ConvNeXt conv block, no BatchNorm)</li> <li><code>maxxvit_rmlp_nano_rw_256</code> - 83.0 @ 256, 83.7 @ 320  (G) (uses ConvNeXt conv block, no BN)</li> <li><code>maxvit_rmlp_small_rw_224</code> - 84.5 @ 224, 85.1 @ 320 (G)</li> <li><code>maxxvit_rmlp_small_rw_256</code> - 84.6 @ 256, 84.9 @ 288 (G) — could be trained better, hparams need tuning (uses ConvNeXt block, no BN)</li> <li><code>coatnet_rmlp_2_rw_224</code> - 84.6 @ 224, 85 @ 320  (T)</li> <li>NOTE: official MaxVit weights (in1k) have been released at <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a> — some extra work is needed to port and adapt since my impl was created independently of theirs and has a few small differences + the whole TF same padding fun.</li></ul></li>',wa,Li,va,Mi,md="<li>LAION-2B CLIP image towers supported as pretrained backbones for fine-tune or features (no classifier)<ul><li>vit_base_patch32_224_clip_laion2b</li> <li>vit_large_patch14_224_clip_laion2b</li> <li>vit_huge_patch14_224_clip_laion2b</li> <li>vit_giant_patch14_224_clip_laion2b</li></ul></li>",ba,Ai,ka,Ci,cd='<li>Hugging Face <a href="https://huggingface.co/docs/hub/timm" rel="nofollow"><code>timm</code> docs</a> home now exists, look for more here in the future</li> <li>Add BEiT-v2 weights for base and large 224x224 models from <a href="https://github.com/microsoft/unilm/tree/master/beit2" rel="nofollow">https://github.com/microsoft/unilm/tree/master/beit2</a></li> <li>Add more weights in <code>maxxvit</code> series incl a <code>pico</code> (7.5M params, 1.9 GMACs), two <code>tiny</code> variants:<ul><li><code>maxvit_rmlp_pico_rw_256</code> - 80.5 @ 256, 81.3 @ 320  (T)</li> <li><code>maxvit_tiny_rw_224</code> - 83.5 @ 224 (G)</li> <li><code>maxvit_rmlp_tiny_rw_256</code> - 84.2 @ 256, 84.8 @ 320 (T)</li></ul></li>',xa,Hi,$a,Ni,pd="<li>MaxVit window size scales with img_size by default. Add new RelPosMlp MaxViT weight that leverages this:<ul><li><code>maxvit_rmlp_nano_rw_256</code> - 83.0 @ 256, 83.6 @ 320  (T)</li></ul></li>",Ta,Vi,ya,Ei,ud='<li>CoAtNet (<a href="https://arxiv.org/abs/2106.04803" rel="nofollow">https://arxiv.org/abs/2106.04803</a>) and MaxVit (<a href="https://arxiv.org/abs/2204.01697" rel="nofollow">https://arxiv.org/abs/2204.01697</a>) <code>timm</code> original models<ul><li>both found in <a href="https://github.com/rwightman/pytorch-image-models/blob/master/timm/models/maxxvit.py" rel="nofollow"><code>maxxvit.py</code></a> model def, contains numerous experiments outside scope of original papers</li> <li>an unfinished Tensorflow version from MaxVit authors can be found <a href="https://github.com/google-research/maxvit" rel="nofollow">https://github.com/google-research/maxvit</a></li></ul></li> <li>Initial CoAtNet and MaxVit timm pretrained weights (working on more):<ul><li><code>coatnet_nano_rw_224</code> - 81.7 @ 224  (T)</li> <li><code>coatnet_rmlp_nano_rw_224</code> - 82.0 @ 224, 82.8 @ 320 (T)</li> <li><code>coatnet_0_rw_224</code> - 82.4  (T)  — NOTE timm ‘0’ coatnets have 2 more 3rd stage blocks</li> <li><code>coatnet_bn_0_rw_224</code> - 82.4  (T)</li> <li><code>maxvit_nano_rw_256</code> - 82.9 @ 256  (T)</li> <li><code>coatnet_rmlp_1_rw_224</code> - 83.4 @ 224, 84 @ 320  (T)</li> <li><code>coatnet_1_rw_224</code> - 83.6 @ 224 (G)</li> <li>(T) = TPU trained with <code>bits_and_tpu</code> branch training code, (G) = GPU trained</li></ul></li> <li>GCVit (weights adapted from <a href="https://github.com/NVlabs/GCVit" rel="nofollow">https://github.com/NVlabs/GCVit</a>, code 100% <code>timm</code> re-write for license purposes)</li> <li>MViT-V2 (multi-scale vit, adapted from <a href="https://github.com/facebookresearch/mvit" rel="nofollow">https://github.com/facebookresearch/mvit</a>)</li> <li>EfficientFormer (adapted from <a href="https://github.com/snap-research/EfficientFormer" rel="nofollow">https://github.com/snap-research/EfficientFormer</a>)</li> <li>PyramidVisionTransformer-V2 (adapted from <a href="https://github.com/whai362/PVT" rel="nofollow">https://github.com/whai362/PVT</a>)</li> <li>‘Fast Norm’ support for LayerNorm and GroupNorm that avoids float32 upcast w/ AMP (uses APEX LN if available for further boost)</li>',La,Pi,Ma,Ii,wd="<li>ConvNeXt atto weights added<ul><li><code>convnext_atto</code> - 75.7 @ 224, 77.0 @ 288</li> <li><code>convnext_atto_ols</code> - 75.9  @ 224, 77.2 @ 288</li></ul></li>",Aa,Ui,Ca,Fi,vd='<li>More custom ConvNeXt smaller model defs with weights <ul><li><code>convnext_femto</code> - 77.5 @ 224, 78.7 @ 288</li> <li><code>convnext_femto_ols</code> - 77.9  @ 224, 78.9 @ 288</li> <li><code>convnext_pico</code> - 79.5 @ 224, 80.4 @ 288</li> <li><code>convnext_pico_ols</code> - 79.5 @ 224, 80.5 @ 288</li> <li><code>convnext_nano_ols</code> - 80.9 @ 224, 81.6 @ 288</li></ul></li> <li>Updated EdgeNeXt to improve ONNX export, add new base variant and weights from original (<a href="https://github.com/mmaaz60/EdgeNeXt" rel="nofollow">https://github.com/mmaaz60/EdgeNeXt</a>)</li>',Ha,Si,Na,zi,bd='<li>Add freshly minted DeiT-III Medium (width=512, depth=12, num_heads=8) model weights. Thanks <a href="https://github.com/TouvronHugo" rel="nofollow">Hugo Touvron</a>!</li>',Va,Ri,Ea,Bi,kd="<li>All runtime benchmark and validation result csv files are up-to-date!</li> <li>A few more weights &amp; model defs added:<ul><li><code>darknetaa53</code> -  79.8 @ 256, 80.5 @ 288</li> <li><code>convnext_nano</code> - 80.8 @ 224, 81.5 @ 288</li> <li><code>cs3sedarknet_l</code> - 81.2 @ 256, 81.8 @ 288</li> <li><code>cs3darknet_x</code> - 81.8 @ 256, 82.2 @ 288</li> <li><code>cs3sedarknet_x</code> - 82.2 @ 256, 82.7 @ 288</li> <li><code>cs3edgenet_x</code> - 82.2 @ 256, 82.7 @ 288</li> <li><code>cs3se_edgenet_x</code> - 82.8 @ 256, 83.5 @ 320</li></ul></li> <li><code>cs3*</code> weights above all trained on TPU w/ <code>bits_and_tpu</code> branch. Thanks to TRC program!</li> <li>Add output_stride=8 and 16 support to ConvNeXt (dilation)</li> <li>deit3 models not being able to resize pos_emb fixed</li> <li>Version 0.6.7 PyPi release (/w above bug fixes and new weighs since 0.6.5)</li>",Pa,Xi,Ia,ji,xd="More models, more fixes",Ua,Gi,$d='<li>Official research models (w/ weights) added:<ul><li>EdgeNeXt from (<a href="https://github.com/mmaaz60/EdgeNeXt" rel="nofollow">https://github.com/mmaaz60/EdgeNeXt</a>)</li> <li>MobileViT-V2 from (<a href="https://github.com/apple/ml-cvnets" rel="nofollow">https://github.com/apple/ml-cvnets</a>)</li> <li>DeiT III (Revenge of the ViT) from (<a href="https://github.com/facebookresearch/deit" rel="nofollow">https://github.com/facebookresearch/deit</a>)</li></ul></li> <li>My own models:<ul><li>Small <code>ResNet</code> defs added by request with 1 block repeats for both basic and bottleneck (resnet10 and resnet14)</li> <li><code>CspNet</code> refactored with dataclass config, simplified CrossStage3 (<code>cs3</code>) option. These are closer to YOLO-v5+ backbone defs.</li> <li>More relative position vit fiddling. Two <code>srelpos</code> (shared relative position) models trained, and a medium w/ class token.</li> <li>Add an alternate downsample mode to EdgeNeXt and train a <code>small</code> model. Better than original small, but not their new USI trained weights.</li></ul></li> <li>My own model weight results (all ImageNet-1k training)<ul><li><code>resnet10t</code> - 66.5 @ 176, 68.3 @ 224</li> <li><code>resnet14t</code> - 71.3 @ 176, 72.3 @ 224</li> <li><code>resnetaa50</code> - 80.6 @ 224 , 81.6 @ 288</li> <li><code>darknet53</code> -  80.0 @ 256, 80.5 @ 288</li> <li><code>cs3darknet_m</code> - 77.0 @ 256, 77.6 @ 288</li> <li><code>cs3darknet_focus_m</code> - 76.7 @ 256, 77.3 @ 288</li> <li><code>cs3darknet_l</code> - 80.4 @ 256, 80.9 @ 288</li> <li><code>cs3darknet_focus_l</code> - 80.3 @ 256, 80.9 @ 288</li> <li><code>vit_srelpos_small_patch16_224</code> - 81.1 @ 224, 82.1 @ 320</li> <li><code>vit_srelpos_medium_patch16_224</code> - 82.3 @ 224, 83.1 @ 320</li> <li><code>vit_relpos_small_patch16_cls_224</code> - 82.6 @ 224, 83.6 @ 320</li> <li><code>edgnext_small_rw</code> - 79.6 @ 224, 80.4 @ 320</li></ul></li> <li><code>cs3</code>, <code>darknet</code>, and <code>vit_*relpos</code> weights above all trained on TPU thanks to TRC program! Rest trained on overheating GPUs.</li> <li>Hugging Face Hub support fixes verified, demo notebook TBA</li> <li>Pretrained weights / configs can be loaded externally (ie from local disk) w/ support for head adaptation.</li> <li>Add support to change image extensions scanned by <code>timm</code> datasets/parsers. See (<a href="https://github.com/rwightman/pytorch-image-models/pull/1274#issuecomment-1178303103" rel="nofollow">https://github.com/rwightman/pytorch-image-models/pull/1274#issuecomment-1178303103</a>)</li> <li>Default ConvNeXt LayerNorm impl to use <code>F.layer_norm(x.permute(0, 2, 3, 1), ...).permute(0, 3, 1, 2)</code> via <code>LayerNorm2d</code> in all cases. <ul><li>a bit slower than previous custom impl on some hardware (ie Ampere w/ CL), but overall fewer regressions across wider HW / PyTorch version ranges.</li> <li>previous impl exists as <code>LayerNormExp2d</code> in <code>models/layers/norm.py</code></li></ul></li> <li>Numerous bug fixes</li> <li>Currently testing for imminent PyPi 0.6.x release</li> <li>LeViT pretraining of larger models still a WIP, they don’t train well / easily without distillation. Time to add distill support (finally)?</li> <li>ImageNet-22k weight training + finetune ongoing, work on multi-weight support (slowly) chugging along (there are a LOT of weights, sigh) …</li>',Fa,Oi,Sa,Di,Td='<li>Official Swin-V2 models and weights added from (<a href="https://github.com/microsoft/Swin-Transformer" rel="nofollow">https://github.com/microsoft/Swin-Transformer</a>). Cleaned up to support torchscript.</li> <li>Some refactoring for existing <code>timm</code> Swin-V2-CR impl, will likely do a bit more to bring parts closer to official and decide whether to merge some aspects.</li> <li>More Vision Transformer relative position / residual post-norm experiments (all trained on TPU thanks to TRC program)<ul><li><code>vit_relpos_small_patch16_224</code> - 81.5 @ 224, 82.5 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_relpos_medium_patch16_rpn_224</code> - 82.3 @ 224, 83.1 @ 320 — rel pos + res-post-norm, no class token, avg pool</li> <li><code>vit_relpos_medium_patch16_224</code> - 82.5 @ 224, 83.3 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_relpos_base_patch16_gapcls_224</code> - 82.8 @ 224, 83.9 @ 320 — rel pos, layer scale, class token, avg pool (by mistake)</li></ul></li> <li>Bring 512 dim, 8-head ‘medium’ ViT model variant back to life (after using in a pre DeiT ‘small’ model for first ViT impl back in 2020)</li> <li>Add ViT relative position support for switching btw existing impl and some additions in official Swin-V2 impl for future trials</li> <li>Sequencer2D impl (<a href="https://arxiv.org/abs/2205.01972" rel="nofollow">https://arxiv.org/abs/2205.01972</a>), added via PR from author (<a href="https://github.com/okojoalg" rel="nofollow">https://github.com/okojoalg</a>)</li>',za,Ji,Ra,qi,yd="<li>Vision Transformer experiments adding Relative Position (Swin-V2 log-coord) (<code>vision_transformer_relpos.py</code>) and Residual Post-Norm branches (from Swin-V2) (<code>vision_transformer*.py</code>)<ul><li><code>vit_relpos_base_patch32_plus_rpn_256</code> - 79.5 @ 256, 80.6 @ 320 — rel pos + extended width + res-post-norm, no class token, avg pool</li> <li><code>vit_relpos_base_patch16_224</code> - 82.5 @ 224, 83.6 @ 320 — rel pos, layer scale, no class token, avg pool</li> <li><code>vit_base_patch16_rpn_224</code> - 82.3 @ 224 — rel pos + res-post-norm, no class token, avg pool</li></ul></li> <li>Vision Transformer refactor to remove representation layer that was only used in initial vit and rarely used since with newer pretrain (ie <code>How to Train Your ViT</code>)</li> <li><code>vit_*</code> models support removal of class token, use of global average pool, use of fc_norm (ala beit, mae).</li>",Ba,Wi,Xa,Yi,Ld='<li><code>timm</code> models are now officially supported in <a href="https://www.fast.ai/" rel="nofollow">fast.ai</a>! Just in time for the new Practical Deep Learning course. <code>timmdocs</code> documentation link updated to <a href="http://timm.fast.ai/" rel="nofollow">timm.fast.ai</a>.</li> <li>Two more model weights added in the TPU trained <a href="https://github.com/rwightman/pytorch-image-models/releases/tag/v0.1-tpu-weights" rel="nofollow">series</a>. Some In22k pretrain still in progress.<ul><li><code>seresnext101d_32x8d</code> - 83.69 @ 224, 84.35 @ 288</li> <li><code>seresnextaa101d_32x8d</code> (anti-aliased w/ AvgPool2d) - 83.85 @ 224, 84.57 @ 288</li></ul></li>',ja,Ki,Ga,Qi,Md='<li>Add <code>ParallelBlock</code> and <code>LayerScale</code> option to base vit models to support model configs in <a href="https://arxiv.org/abs/2203.09795" rel="nofollow">Three things everyone should know about ViT</a></li> <li><code>convnext_tiny_hnf</code> (head norm first) weights trained with (close to) A2 recipe, 82.2% top-1, could do better with more epochs.</li>',Oa,Zi,Da,te,Ad='<li>Merge <code>norm_norm_norm</code>. <strong>IMPORTANT</strong> this update for a coming 0.6.x release will likely de-stabilize the master branch for a while. Branch <a href="https://github.com/rwightman/pytorch-image-models/tree/0.5.x" rel="nofollow"><code>0.5.x</code></a> or a previous 0.5.x release can be used if stability is required.</li> <li>Significant weights update (all TPU trained) as described in this <a href="https://github.com/rwightman/pytorch-image-models/releases/tag/v0.1-tpu-weights" rel="nofollow">release</a><ul><li><code>regnety_040</code> - 82.3 @ 224, 82.96 @ 288</li> <li><code>regnety_064</code> - 83.0 @ 224, 83.65 @ 288</li> <li><code>regnety_080</code> - 83.17 @ 224, 83.86 @ 288</li> <li><code>regnetv_040</code> - 82.44 @ 224, 83.18 @ 288   (timm pre-act)</li> <li><code>regnetv_064</code> - 83.1 @ 224, 83.71 @ 288   (timm pre-act)</li> <li><code>regnetz_040</code> - 83.67 @ 256, 84.25 @ 320</li> <li><code>regnetz_040h</code> - 83.77 @ 256, 84.5 @ 320 (w/ extra fc in head)</li> <li><code>resnetv2_50d_gn</code> - 80.8 @ 224, 81.96 @ 288 (pre-act GroupNorm)</li> <li><code>resnetv2_50d_evos</code> 80.77 @ 224, 82.04 @ 288 (pre-act EvoNormS)</li> <li><code>regnetz_c16_evos</code>  - 81.9 @ 256, 82.64 @ 320 (EvoNormS)</li> <li><code>regnetz_d8_evos</code>  - 83.42 @ 256, 84.04 @ 320 (EvoNormS)</li> <li><code>xception41p</code> - 82 @ 299   (timm pre-act)</li> <li><code>xception65</code> -  83.17 @ 299</li> <li><code>xception65p</code> -  83.14 @ 299   (timm pre-act)</li> <li><code>resnext101_64x4d</code> - 82.46 @ 224, 83.16 @ 288</li> <li><code>seresnext101_32x8d</code> - 83.57 @ 224, 84.270 @ 288</li> <li><code>resnetrs200</code> - 83.85 @ 256, 84.44 @ 320</li></ul></li> <li>HuggingFace hub support fixed w/ initial groundwork for allowing alternative ‘config sources’ for pretrained model definitions and weights (generic local file / remote url support soon)</li> <li>SwinTransformer-V2 implementation added. Submitted by <a href="https://github.com/ChristophReich1996" rel="nofollow">Christoph Reich</a>. Training experiments and model changes by myself are ongoing so expect compat breaks.</li> <li>Swin-S3 (AutoFormerV2) models / weights added from <a href="https://github.com/microsoft/Cream/tree/main/AutoFormerV2" rel="nofollow">https://github.com/microsoft/Cream/tree/main/AutoFormerV2</a></li> <li>MobileViT models w/ weights adapted from <a href="https://github.com/apple/ml-cvnets" rel="nofollow">https://github.com/apple/ml-cvnets</a></li> <li>PoolFormer models w/ weights adapted from <a href="https://github.com/sail-sg/poolformer" rel="nofollow">https://github.com/sail-sg/poolformer</a></li> <li>VOLO models w/ weights adapted from <a href="https://github.com/sail-sg/volo" rel="nofollow">https://github.com/sail-sg/volo</a></li> <li>Significant work experimenting with non-BatchNorm norm layers such as EvoNorm, FilterResponseNorm, GroupNorm, etc</li> <li>Enhance support for alternate norm + act (‘NormAct’) layers added to a number of models, esp EfficientNet/MobileNetV3, RegNet, and aligned Xception</li> <li>Grouped conv support added to EfficientNet family</li> <li>Add ‘group matching’ API to all models to allow grouping model parameters for application of ‘layer-wise’ LR decay, lr scale added to LR scheduler</li> <li>Gradient checkpointing support added to many models</li> <li><code>forward_head(x, pre_logits=False)</code> fn added to all models to allow separate calls of <code>forward_features</code> + <code>forward_head</code></li> <li>All vision transformer and vision MLP models update to return non-pooled / non-token selected features from <code>foward_features</code>, for consistency with CNN models, token selection or pooling now applied in <code>forward_head</code></li>',Ja,ie,qa,ee,Cd='<li><a href="https://github.com/Chris-hughes10" rel="nofollow">Chris Hughes</a> posted an exhaustive run through of <code>timm</code> on his blog yesterday. Well worth a read. <a href="https://towardsdatascience.com/getting-started-with-pytorch-image-models-timm-a-practitioners-guide-4e77b4bf9055" rel="nofollow">Getting Started with PyTorch Image Models (timm): A Practitioner’s Guide</a></li> <li>I’m currently prepping to merge the <code>norm_norm_norm</code> branch back to master (ver 0.6.x) in next week or so.<ul><li>The changes are more extensive than usual and may destabilize and break some model API use (aiming for full backwards compat). So, beware <code>pip install git+https://github.com/rwightman/pytorch-image-models</code> installs!</li> <li><code>0.5.x</code> releases and a <code>0.5.x</code> branch will remain stable with a cherry pick or two until dust clears. Recommend sticking to pypi install for a bit if you want stable.</li></ul></li>',Wa,le,Ya,ae,Hd='<li>Version 0.5.4 w/ release to be pushed to pypi. It’s been a while since last pypi update and riskier changes will be merged to main branch soon…</li> <li>Add ConvNeXT models /w weights from official impl (<a href="https://github.com/facebookresearch/ConvNeXt" rel="nofollow">https://github.com/facebookresearch/ConvNeXt</a>), a few perf tweaks, compatible with timm features</li> <li>Tried training a few small (~1.8-3M param) / mobile optimized models, a few are good so far, more on the way…<ul><li><code>mnasnet_small</code> - 65.6 top-1</li> <li><code>mobilenetv2_050</code> - 65.9</li> <li><code>lcnet_100/075/050</code> - 72.1 / 68.8 / 63.1</li> <li><code>semnasnet_075</code> - 73</li> <li><code>fbnetv3_b/d/g</code> - 79.1 / 79.7 / 82.0</li></ul></li> <li>TinyNet models added by <a href="https://github.com/rsomani95" rel="nofollow">rsomani95</a></li> <li>LCNet added via MobileNetV3 architecture</li>',Ka,ne,Qa,oe,Za;return u=new c({props:{title:"Recent Changes",local:"recent-changes",headingTag:"h1"}}),w=new c({props:{title:"Aug 28, 2023",local:"aug-28-2023",headingTag:"h3"}}),b=new c({props:{title:"Aug 25, 2023",local:"aug-25-2023",headingTag:"h3"}}),x=new c({props:{title:"Aug 11, 2023",local:"aug-11-2023",headingTag:"h3"}}),T=new c({props:{title:"Aug 3, 2023",local:"aug-3-2023",headingTag:"h3"}}),L=new c({props:{title:"July 27, 2023",local:"july-27-2023",headingTag:"h3"}}),A=new c({props:{title:"May 11, 2023",local:"may-11-2023",headingTag:"h3"}}),H=new c({props:{title:"May 10, 2023",local:"may-10-2023",headingTag:"h3"}}),V=new c({props:{title:"April 27, 2023",local:"april-27-2023",headingTag:"h3"}}),P=new c({props:{title:"April 21, 2023",local:"april-21-2023",headingTag:"h3"}}),U=new c({props:{title:"April 12, 2023",local:"april-12-2023",headingTag:"h3"}}),S=new c({props:{title:"April 5, 2023",local:"april-5-2023",headingTag:"h3"}}),R=new c({props:{title:"March 31, 2023",local:"march-31-2023",headingTag:"h3"}}),D=new c({props:{title:"March 22, 2023",local:"march-22-2023",headingTag:"h3"}}),q=new c({props:{title:"Feb 26, 2023",local:"feb-26-2023",headingTag:"h3"}}),Y=new c({props:{title:"Feb 20, 2023",local:"feb-20-2023",headingTag:"h3"}}),Q=new c({props:{title:"Feb 16, 2023",local:"feb-16-2023",headingTag:"h3"}}),tt=new c({props:{title:"Feb 7, 2023",local:"feb-7-2023",headingTag:"h3"}}),et=new c({props:{title:"Jan 20, 2023",local:"jan-20-2023",headingTag:"h3"}}),nt=new c({props:{title:"Jan 11, 2023",local:"jan-11-2023",headingTag:"h3"}}),ot=new c({props:{title:"Jan 6, 2023",local:"jan-6-2023",headingTag:"h3"}}),gt=new c({props:{title:"Jan 5, 2023",local:"jan-5-2023",headingTag:"h3"}}),st=new c({props:{title:"Dec 23, 2022 🎄☃",local:"dec-23-2022-",headingTag:"h3"}}),_t=new c({props:{title:"Dec 8, 2022",local:"dec-8-2022",headingTag:"h3"}}),pt=new c({props:{title:"Dec 6, 2022",local:"dec-6-2022",headingTag:"h3"}}),vt=new c({props:{title:"Dec 5, 2022",local:"dec-5-2022",headingTag:"h3"}}),Tt=new c({props:{title:"Oct 15, 2022",local:"oct-15-2022",headingTag:"h3"}}),Lt=new c({props:{title:"Oct 10, 2022",local:"oct-10-2022",headingTag:"h3"}}),At=new c({props:{title:"Sept 23, 2022",local:"sept-23-2022",headingTag:"h3"}}),Ht=new c({props:{title:"Sept 7, 2022",local:"sept-7-2022",headingTag:"h3"}}),Vt=new c({props:{title:"Aug 29, 2022",local:"aug-29-2022",headingTag:"h3"}}),Pt=new c({props:{title:"Aug 26, 2022",local:"aug-26-2022",headingTag:"h3"}}),Ut=new c({props:{title:"Aug 15, 2022",local:"aug-15-2022",headingTag:"h3"}}),St=new c({props:{title:"Aug 5, 2022",local:"aug-5-2022",headingTag:"h3"}}),Rt=new c({props:{title:"July 28, 2022",local:"july-28-2022",headingTag:"h3"}}),Xt=new c({props:{title:"July 27, 2022",local:"july-27-2022",headingTag:"h3"}}),Gt=new c({props:{title:"July 8, 2022",local:"july-8-2022",headingTag:"h3"}}),Jt=new c({props:{title:"May 13, 2022",local:"may-13-2022",headingTag:"h3"}}),Wt=new c({props:{title:"May 2, 2022",local:"may-2-2022",headingTag:"h3"}}),Kt=new c({props:{title:"April 22, 2022",local:"april-22-2022",headingTag:"h3"}}),Zt=new c({props:{title:"March 23, 2022",local:"march-23-2022",headingTag:"h3"}}),ii=new c({props:{title:"March 21, 2022",local:"march-21-2022",headingTag:"h3"}}),li=new c({props:{title:"Feb 2, 2022",local:"feb-2-2022",headingTag:"h3"}}),ni=new c({props:{title:"Jan 14, 2022",local:"jan-14-2022",headingTag:"h3"}}),oi=new c({props:{title:"Jan 5, 2023",local:"jan-5-2023",headingTag:"h3"}}),gi=new c({props:{title:"Dec 23, 2022 🎄☃",local:"dec-23-2022-",headingTag:"h3"}}),si=new c({props:{title:"Dec 8, 2022",local:"dec-8-2022",headingTag:"h3"}}),mi=new c({props:{title:"Dec 6, 2022",local:"dec-6-2022",headingTag:"h3"}}),ui=new c({props:{title:"Dec 5, 2022",local:"dec-5-2022",headingTag:"h3"}}),xi=new c({props:{title:"Oct 15, 2022",local:"oct-15-2022",headingTag:"h3"}}),Ti=new c({props:{title:"Oct 10, 2022",local:"oct-10-2022",headingTag:"h3"}}),Li=new c({props:{title:"Sept 23, 2022",local:"sept-23-2022",headingTag:"h3"}}),Ai=new c({props:{title:"Sept 7, 2022",local:"sept-7-2022",headingTag:"h3"}}),Hi=new c({props:{title:"Aug 29, 2022",local:"aug-29-2022",headingTag:"h3"}}),Vi=new c({props:{title:"Aug 26, 2022",local:"aug-26-2022",headingTag:"h3"}}),Pi=new c({props:{title:"Aug 15, 2022",local:"aug-15-2022",headingTag:"h3"}}),Ui=new c({props:{title:"Aug 5, 2022",local:"aug-5-2022",headingTag:"h3"}}),Si=new c({props:{title:"July 28, 2022",local:"july-28-2022",headingTag:"h3"}}),Ri=new c({props:{title:"July 27, 2022",local:"july-27-2022",headingTag:"h3"}}),Xi=new c({props:{title:"July 8, 2022",local:"july-8-2022",headingTag:"h3"}}),Oi=new c({props:{title:"May 13, 2022",local:"may-13-2022",headingTag:"h3"}}),Ji=new c({props:{title:"May 2, 2022",local:"may-2-2022",headingTag:"h3"}}),Wi=new c({props:{title:"April 22, 2022",local:"april-22-2022",headingTag:"h3"}}),Ki=new c({props:{title:"March 23, 2022",local:"march-23-2022",headingTag:"h3"}}),Zi=new c({props:{title:"March 21, 2022",local:"march-21-2022",headingTag:"h3"}}),ie=new c({props:{title:"Feb 2, 2022",local:"feb-2-2022",headingTag:"h3"}}),le=new c({props:{title:"Jan 14, 2022",local:"jan-14-2022",headingTag:"h3"}}),ne=new Rd({props:{source:"https://github.com/huggingface/pytorch-image-models/blob/main/hfdocs/source/changes.mdx"}}),{c(){p=d("meta"),re=a(),de=d("p"),ge=a(),g(u.$$.fragment),he=a(),g(w.$$.fragment),se=a(),v=d("ul"),v.innerHTML=en,fe=a(),g(b.$$.fragment),_e=a(),k=d("ul"),k.innerHTML=ln,me=a(),g(x.$$.fragment),ce=a(),$=d("ul"),$.innerHTML=an,pe=a(),g(T.$$.fragment),ue=a(),y=d("ul"),y.innerHTML=nn,we=a(),g(L.$$.fragment),ve=a(),M=d("ul"),M.innerHTML=dn,be=a(),g(A.$$.fragment),ke=a(),C=d("ul"),C.innerHTML=on,xe=a(),g(H.$$.fragment),$e=a(),N=d("ul"),N.innerHTML=rn,Te=a(),g(V.$$.fragment),ye=a(),E=d("ul"),E.innerHTML=gn,Le=a(),g(P.$$.fragment),Me=a(),I=d("ul"),I.innerHTML=hn,Ae=a(),g(U.$$.fragment),Ce=a(),F=d("ul"),F.innerHTML=sn,He=a(),g(S.$$.fragment),Ne=a(),z=d("ul"),z.innerHTML=fn,Ve=a(),g(R.$$.fragment),Ee=a(),B=d("ul"),B.innerHTML=_n,Pe=a(),X=d("table"),X.innerHTML=mn,Ie=a(),j=d("ul"),j.innerHTML=cn,Ue=a(),G=d("table"),G.innerHTML=pn,Fe=a(),O=d("ul"),O.innerHTML=un,Se=a(),g(D.$$.fragment),ze=a(),J=d("ul"),J.innerHTML=wn,Re=a(),g(q.$$.fragment),Be=a(),W=d("ul"),W.innerHTML=vn,Xe=a(),g(Y.$$.fragment),je=a(),K=d("ul"),K.innerHTML=bn,Ge=a(),g(Q.$$.fragment),Oe=a(),Z=d("ul"),Z.innerHTML=kn,De=a(),g(tt.$$.fragment),Je=a(),it=d("ul"),it.innerHTML=xn,qe=a(),g(et.$$.fragment),We=a(),lt=d("ul"),lt.innerHTML=$n,Ye=a(),at=d("table"),at.innerHTML=Tn,Ke=a(),g(nt.$$.fragment),Qe=a(),dt=d("ul"),dt.innerHTML=yn,Ze=a(),g(ot.$$.fragment),tl=a(),rt=d("ul"),rt.innerHTML=Ln,il=a(),g(gt.$$.fragment),el=a(),ht=d("ul"),ht.innerHTML=Mn,ll=a(),g(st.$$.fragment),al=a(),ft=d("ul"),ft.innerHTML=An,nl=a(),g(_t.$$.fragment),dl=a(),mt=d("ul"),mt.innerHTML=Cn,ol=a(),ct=d("table"),ct.innerHTML=Hn,rl=a(),g(pt.$$.fragment),gl=a(),ut=d("ul"),ut.innerHTML=Nn,hl=a(),wt=d("table"),wt.innerHTML=Vn,sl=a(),g(vt.$$.fragment),fl=a(),bt=d("ul"),bt.innerHTML=En,_l=a(),kt=d("table"),kt.innerHTML=Pn,ml=a(),xt=d("ul"),xt.innerHTML=In,cl=a(),$t=d("table"),$t.innerHTML=Un,pl=a(),g(Tt.$$.fragment),ul=a(),yt=d("ul"),yt.innerHTML=Fn,wl=a(),g(Lt.$$.fragment),vl=a(),Mt=d("ul"),Mt.innerHTML=Sn,bl=a(),g(At.$$.fragment),kl=a(),Ct=d("ul"),Ct.innerHTML=zn,xl=a(),g(Ht.$$.fragment),$l=a(),Nt=d("ul"),Nt.innerHTML=Rn,Tl=a(),g(Vt.$$.fragment),yl=a(),Et=d("ul"),Et.innerHTML=Bn,Ll=a(),g(Pt.$$.fragment),Ml=a(),It=d("ul"),It.innerHTML=Xn,Al=a(),g(Ut.$$.fragment),Cl=a(),Ft=d("ul"),Ft.innerHTML=jn,Hl=a(),g(St.$$.fragment),Nl=a(),zt=d("ul"),zt.innerHTML=Gn,Vl=a(),g(Rt.$$.fragment),El=a(),Bt=d("ul"),Bt.innerHTML=On,Pl=a(),g(Xt.$$.fragment),Il=a(),jt=d("ul"),jt.innerHTML=Dn,Ul=a(),g(Gt.$$.fragment),Fl=a(),Ot=d("p"),Ot.textContent=Jn,Sl=a(),Dt=d("ul"),Dt.innerHTML=qn,zl=a(),g(Jt.$$.fragment),Rl=a(),qt=d("ul"),qt.innerHTML=Wn,Bl=a(),g(Wt.$$.fragment),Xl=a(),Yt=d("ul"),Yt.innerHTML=Yn,jl=a(),g(Kt.$$.fragment),Gl=a(),Qt=d("ul"),Qt.innerHTML=Kn,Ol=a(),g(Zt.$$.fragment),Dl=a(),ti=d("ul"),ti.innerHTML=Qn,Jl=a(),g(ii.$$.fragment),ql=a(),ei=d("ul"),ei.innerHTML=Zn,Wl=a(),g(li.$$.fragment),Yl=a(),ai=d("ul"),ai.innerHTML=td,Kl=a(),g(ni.$$.fragment),Ql=a(),di=d("ul"),di.innerHTML=id,Zl=a(),g(oi.$$.fragment),ta=a(),ri=d("ul"),ri.innerHTML=ed,ia=a(),g(gi.$$.fragment),ea=a(),hi=d("ul"),hi.innerHTML=ld,la=a(),g(si.$$.fragment),aa=a(),fi=d("ul"),fi.innerHTML=ad,na=a(),_i=d("table"),_i.innerHTML=nd,da=a(),g(mi.$$.fragment),oa=a(),ci=d("ul"),ci.innerHTML=dd,ra=a(),pi=d("table"),pi.innerHTML=od,ga=a(),g(ui.$$.fragment),ha=a(),wi=d("ul"),wi.innerHTML=rd,sa=a(),vi=d("table"),vi.innerHTML=gd,fa=a(),bi=d("ul"),bi.innerHTML=hd,_a=a(),ki=d("table"),ki.innerHTML=sd,ma=a(),g(xi.$$.fragment),ca=a(),$i=d("ul"),$i.innerHTML=fd,pa=a(),g(Ti.$$.fragment),ua=a(),yi=d("ul"),yi.innerHTML=_d,wa=a(),g(Li.$$.fragment),va=a(),Mi=d("ul"),Mi.innerHTML=md,ba=a(),g(Ai.$$.fragment),ka=a(),Ci=d("ul"),Ci.innerHTML=cd,xa=a(),g(Hi.$$.fragment),$a=a(),Ni=d("ul"),Ni.innerHTML=pd,Ta=a(),g(Vi.$$.fragment),ya=a(),Ei=d("ul"),Ei.innerHTML=ud,La=a(),g(Pi.$$.fragment),Ma=a(),Ii=d("ul"),Ii.innerHTML=wd,Aa=a(),g(Ui.$$.fragment),Ca=a(),Fi=d("ul"),Fi.innerHTML=vd,Ha=a(),g(Si.$$.fragment),Na=a(),zi=d("ul"),zi.innerHTML=bd,Va=a(),g(Ri.$$.fragment),Ea=a(),Bi=d("ul"),Bi.innerHTML=kd,Pa=a(),g(Xi.$$.fragment),Ia=a(),ji=d("p"),ji.textContent=xd,Ua=a(),Gi=d("ul"),Gi.innerHTML=$d,Fa=a(),g(Oi.$$.fragment),Sa=a(),Di=d("ul"),Di.innerHTML=Td,za=a(),g(Ji.$$.fragment),Ra=a(),qi=d("ul"),qi.innerHTML=yd,Ba=a(),g(Wi.$$.fragment),Xa=a(),Yi=d("ul"),Yi.innerHTML=Ld,ja=a(),g(Ki.$$.fragment),Ga=a(),Qi=d("ul"),Qi.innerHTML=Md,Oa=a(),g(Zi.$$.fragment),Da=a(),te=d("ul"),te.innerHTML=Ad,Ja=a(),g(ie.$$.fragment),qa=a(),ee=d("ul"),ee.innerHTML=Cd,Wa=a(),g(le.$$.fragment),Ya=a(),ae=d("ul"),ae.innerHTML=Hd,Ka=a(),g(ne.$$.fragment),Qa=a(),oe=d("p"),this.h()},l(t){const i=Sd("svelte-u9bgzb",document.head);p=o(i,"META",{name:!0,content:!0}),i.forEach(e),re=n(t),de=o(t,"P",{}),Nd(de).forEach(e),ge=n(t),h(u.$$.fragment,t),he=n(t),h(w.$$.fragment,t),se=n(t),v=o(t,"UL",{"data-svelte-h":!0}),r(v)!=="svelte-o5zlwd"&&(v.innerHTML=en),fe=n(t),h(b.$$.fragment,t),_e=n(t),k=o(t,"UL",{"data-svelte-h":!0}),r(k)!=="svelte-1spql0o"&&(k.innerHTML=ln),me=n(t),h(x.$$.fragment,t),ce=n(t),$=o(t,"UL",{"data-svelte-h":!0}),r($)!=="svelte-vllwli"&&($.innerHTML=an),pe=n(t),h(T.$$.fragment,t),ue=n(t),y=o(t,"UL",{"data-svelte-h":!0}),r(y)!=="svelte-1emosi9"&&(y.innerHTML=nn),we=n(t),h(L.$$.fragment,t),ve=n(t),M=o(t,"UL",{"data-svelte-h":!0}),r(M)!=="svelte-zhgqqt"&&(M.innerHTML=dn),be=n(t),h(A.$$.fragment,t),ke=n(t),C=o(t,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-gifogx"&&(C.innerHTML=on),xe=n(t),h(H.$$.fragment,t),$e=n(t),N=o(t,"UL",{"data-svelte-h":!0}),r(N)!=="svelte-18h01cj"&&(N.innerHTML=rn),Te=n(t),h(V.$$.fragment,t),ye=n(t),E=o(t,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-cwpusb"&&(E.innerHTML=gn),Le=n(t),h(P.$$.fragment,t),Me=n(t),I=o(t,"UL",{"data-svelte-h":!0}),r(I)!=="svelte-nnrgzx"&&(I.innerHTML=hn),Ae=n(t),h(U.$$.fragment,t),Ce=n(t),F=o(t,"UL",{"data-svelte-h":!0}),r(F)!=="svelte-1n3jsdn"&&(F.innerHTML=sn),He=n(t),h(S.$$.fragment,t),Ne=n(t),z=o(t,"UL",{"data-svelte-h":!0}),r(z)!=="svelte-jmvfgb"&&(z.innerHTML=fn),Ve=n(t),h(R.$$.fragment,t),Ee=n(t),B=o(t,"UL",{"data-svelte-h":!0}),r(B)!=="svelte-1nof9x1"&&(B.innerHTML=_n),Pe=n(t),X=o(t,"TABLE",{"data-svelte-h":!0}),r(X)!=="svelte-beoh8"&&(X.innerHTML=mn),Ie=n(t),j=o(t,"UL",{"data-svelte-h":!0}),r(j)!=="svelte-499b69"&&(j.innerHTML=cn),Ue=n(t),G=o(t,"TABLE",{"data-svelte-h":!0}),r(G)!=="svelte-12ymbo6"&&(G.innerHTML=pn),Fe=n(t),O=o(t,"UL",{"data-svelte-h":!0}),r(O)!=="svelte-1n8fcr3"&&(O.innerHTML=un),Se=n(t),h(D.$$.fragment,t),ze=n(t),J=o(t,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-1opkf16"&&(J.innerHTML=wn),Re=n(t),h(q.$$.fragment,t),Be=n(t),W=o(t,"UL",{"data-svelte-h":!0}),r(W)!=="svelte-kdfxn"&&(W.innerHTML=vn),Xe=n(t),h(Y.$$.fragment,t),je=n(t),K=o(t,"UL",{"data-svelte-h":!0}),r(K)!=="svelte-t8szp7"&&(K.innerHTML=bn),Ge=n(t),h(Q.$$.fragment,t),Oe=n(t),Z=o(t,"UL",{"data-svelte-h":!0}),r(Z)!=="svelte-1n2berl"&&(Z.innerHTML=kn),De=n(t),h(tt.$$.fragment,t),Je=n(t),it=o(t,"UL",{"data-svelte-h":!0}),r(it)!=="svelte-45t6sb"&&(it.innerHTML=xn),qe=n(t),h(et.$$.fragment,t),We=n(t),lt=o(t,"UL",{"data-svelte-h":!0}),r(lt)!=="svelte-3zs485"&&(lt.innerHTML=$n),Ye=n(t),at=o(t,"TABLE",{"data-svelte-h":!0}),r(at)!=="svelte-1jw3h7v"&&(at.innerHTML=Tn),Ke=n(t),h(nt.$$.fragment,t),Qe=n(t),dt=o(t,"UL",{"data-svelte-h":!0}),r(dt)!=="svelte-15wsr73"&&(dt.innerHTML=yn),Ze=n(t),h(ot.$$.fragment,t),tl=n(t),rt=o(t,"UL",{"data-svelte-h":!0}),r(rt)!=="svelte-2am2wk"&&(rt.innerHTML=Ln),il=n(t),h(gt.$$.fragment,t),el=n(t),ht=o(t,"UL",{"data-svelte-h":!0}),r(ht)!=="svelte-v6i5yp"&&(ht.innerHTML=Mn),ll=n(t),h(st.$$.fragment,t),al=n(t),ft=o(t,"UL",{"data-svelte-h":!0}),r(ft)!=="svelte-hz5yxo"&&(ft.innerHTML=An),nl=n(t),h(_t.$$.fragment,t),dl=n(t),mt=o(t,"UL",{"data-svelte-h":!0}),r(mt)!=="svelte-1ybsdar"&&(mt.innerHTML=Cn),ol=n(t),ct=o(t,"TABLE",{"data-svelte-h":!0}),r(ct)!=="svelte-1kdm8f8"&&(ct.innerHTML=Hn),rl=n(t),h(pt.$$.fragment,t),gl=n(t),ut=o(t,"UL",{"data-svelte-h":!0}),r(ut)!=="svelte-90svo3"&&(ut.innerHTML=Nn),hl=n(t),wt=o(t,"TABLE",{"data-svelte-h":!0}),r(wt)!=="svelte-1jlkusq"&&(wt.innerHTML=Vn),sl=n(t),h(vt.$$.fragment,t),fl=n(t),bt=o(t,"UL",{"data-svelte-h":!0}),r(bt)!=="svelte-1f4joci"&&(bt.innerHTML=En),_l=n(t),kt=o(t,"TABLE",{"data-svelte-h":!0}),r(kt)!=="svelte-1w1dpjo"&&(kt.innerHTML=Pn),ml=n(t),xt=o(t,"UL",{"data-svelte-h":!0}),r(xt)!=="svelte-mr00b7"&&(xt.innerHTML=In),cl=n(t),$t=o(t,"TABLE",{"data-svelte-h":!0}),r($t)!=="svelte-uhceid"&&($t.innerHTML=Un),pl=n(t),h(Tt.$$.fragment,t),ul=n(t),yt=o(t,"UL",{"data-svelte-h":!0}),r(yt)!=="svelte-a95su3"&&(yt.innerHTML=Fn),wl=n(t),h(Lt.$$.fragment,t),vl=n(t),Mt=o(t,"UL",{"data-svelte-h":!0}),r(Mt)!=="svelte-w97o2d"&&(Mt.innerHTML=Sn),bl=n(t),h(At.$$.fragment,t),kl=n(t),Ct=o(t,"UL",{"data-svelte-h":!0}),r(Ct)!=="svelte-1dx7og"&&(Ct.innerHTML=zn),xl=n(t),h(Ht.$$.fragment,t),$l=n(t),Nt=o(t,"UL",{"data-svelte-h":!0}),r(Nt)!=="svelte-8zju9s"&&(Nt.innerHTML=Rn),Tl=n(t),h(Vt.$$.fragment,t),yl=n(t),Et=o(t,"UL",{"data-svelte-h":!0}),r(Et)!=="svelte-e4xo5p"&&(Et.innerHTML=Bn),Ll=n(t),h(Pt.$$.fragment,t),Ml=n(t),It=o(t,"UL",{"data-svelte-h":!0}),r(It)!=="svelte-1ho7x52"&&(It.innerHTML=Xn),Al=n(t),h(Ut.$$.fragment,t),Cl=n(t),Ft=o(t,"UL",{"data-svelte-h":!0}),r(Ft)!=="svelte-19s36kx"&&(Ft.innerHTML=jn),Hl=n(t),h(St.$$.fragment,t),Nl=n(t),zt=o(t,"UL",{"data-svelte-h":!0}),r(zt)!=="svelte-uqojig"&&(zt.innerHTML=Gn),Vl=n(t),h(Rt.$$.fragment,t),El=n(t),Bt=o(t,"UL",{"data-svelte-h":!0}),r(Bt)!=="svelte-pdc04g"&&(Bt.innerHTML=On),Pl=n(t),h(Xt.$$.fragment,t),Il=n(t),jt=o(t,"UL",{"data-svelte-h":!0}),r(jt)!=="svelte-psmz9t"&&(jt.innerHTML=Dn),Ul=n(t),h(Gt.$$.fragment,t),Fl=n(t),Ot=o(t,"P",{"data-svelte-h":!0}),r(Ot)!=="svelte-14yj5kr"&&(Ot.textContent=Jn),Sl=n(t),Dt=o(t,"UL",{"data-svelte-h":!0}),r(Dt)!=="svelte-1ocq7qf"&&(Dt.innerHTML=qn),zl=n(t),h(Jt.$$.fragment,t),Rl=n(t),qt=o(t,"UL",{"data-svelte-h":!0}),r(qt)!=="svelte-1ksbgxy"&&(qt.innerHTML=Wn),Bl=n(t),h(Wt.$$.fragment,t),Xl=n(t),Yt=o(t,"UL",{"data-svelte-h":!0}),r(Yt)!=="svelte-1phzket"&&(Yt.innerHTML=Yn),jl=n(t),h(Kt.$$.fragment,t),Gl=n(t),Qt=o(t,"UL",{"data-svelte-h":!0}),r(Qt)!=="svelte-1whjijd"&&(Qt.innerHTML=Kn),Ol=n(t),h(Zt.$$.fragment,t),Dl=n(t),ti=o(t,"UL",{"data-svelte-h":!0}),r(ti)!=="svelte-1dzgmu6"&&(ti.innerHTML=Qn),Jl=n(t),h(ii.$$.fragment,t),ql=n(t),ei=o(t,"UL",{"data-svelte-h":!0}),r(ei)!=="svelte-abrsee"&&(ei.innerHTML=Zn),Wl=n(t),h(li.$$.fragment,t),Yl=n(t),ai=o(t,"UL",{"data-svelte-h":!0}),r(ai)!=="svelte-rnuh6y"&&(ai.innerHTML=td),Kl=n(t),h(ni.$$.fragment,t),Ql=n(t),di=o(t,"UL",{"data-svelte-h":!0}),r(di)!=="svelte-7l2ez"&&(di.innerHTML=id),Zl=n(t),h(oi.$$.fragment,t),ta=n(t),ri=o(t,"UL",{"data-svelte-h":!0}),r(ri)!=="svelte-jygzt1"&&(ri.innerHTML=ed),ia=n(t),h(gi.$$.fragment,t),ea=n(t),hi=o(t,"UL",{"data-svelte-h":!0}),r(hi)!=="svelte-hz5yxo"&&(hi.innerHTML=ld),la=n(t),h(si.$$.fragment,t),aa=n(t),fi=o(t,"UL",{"data-svelte-h":!0}),r(fi)!=="svelte-1ybsdar"&&(fi.innerHTML=ad),na=n(t),_i=o(t,"TABLE",{"data-svelte-h":!0}),r(_i)!=="svelte-1kdm8f8"&&(_i.innerHTML=nd),da=n(t),h(mi.$$.fragment,t),oa=n(t),ci=o(t,"UL",{"data-svelte-h":!0}),r(ci)!=="svelte-1o52qz7"&&(ci.innerHTML=dd),ra=n(t),pi=o(t,"TABLE",{"data-svelte-h":!0}),r(pi)!=="svelte-1jlkusq"&&(pi.innerHTML=od),ga=n(t),h(ui.$$.fragment,t),ha=n(t),wi=o(t,"UL",{"data-svelte-h":!0}),r(wi)!=="svelte-1f4joci"&&(wi.innerHTML=rd),sa=n(t),vi=o(t,"TABLE",{"data-svelte-h":!0}),r(vi)!=="svelte-1w1dpjo"&&(vi.innerHTML=gd),fa=n(t),bi=o(t,"UL",{"data-svelte-h":!0}),r(bi)!=="svelte-mr00b7"&&(bi.innerHTML=hd),_a=n(t),ki=o(t,"TABLE",{"data-svelte-h":!0}),r(ki)!=="svelte-uhceid"&&(ki.innerHTML=sd),ma=n(t),h(xi.$$.fragment,t),ca=n(t),$i=o(t,"UL",{"data-svelte-h":!0}),r($i)!=="svelte-a95su3"&&($i.innerHTML=fd),pa=n(t),h(Ti.$$.fragment,t),ua=n(t),yi=o(t,"UL",{"data-svelte-h":!0}),r(yi)!=="svelte-w97o2d"&&(yi.innerHTML=_d),wa=n(t),h(Li.$$.fragment,t),va=n(t),Mi=o(t,"UL",{"data-svelte-h":!0}),r(Mi)!=="svelte-1dx7og"&&(Mi.innerHTML=md),ba=n(t),h(Ai.$$.fragment,t),ka=n(t),Ci=o(t,"UL",{"data-svelte-h":!0}),r(Ci)!=="svelte-8zju9s"&&(Ci.innerHTML=cd),xa=n(t),h(Hi.$$.fragment,t),$a=n(t),Ni=o(t,"UL",{"data-svelte-h":!0}),r(Ni)!=="svelte-e4xo5p"&&(Ni.innerHTML=pd),Ta=n(t),h(Vi.$$.fragment,t),ya=n(t),Ei=o(t,"UL",{"data-svelte-h":!0}),r(Ei)!=="svelte-16sk34w"&&(Ei.innerHTML=ud),La=n(t),h(Pi.$$.fragment,t),Ma=n(t),Ii=o(t,"UL",{"data-svelte-h":!0}),r(Ii)!=="svelte-19s36kx"&&(Ii.innerHTML=wd),Aa=n(t),h(Ui.$$.fragment,t),Ca=n(t),Fi=o(t,"UL",{"data-svelte-h":!0}),r(Fi)!=="svelte-1v6eoga"&&(Fi.innerHTML=vd),Ha=n(t),h(Si.$$.fragment,t),Na=n(t),zi=o(t,"UL",{"data-svelte-h":!0}),r(zi)!=="svelte-pdc04g"&&(zi.innerHTML=bd),Va=n(t),h(Ri.$$.fragment,t),Ea=n(t),Bi=o(t,"UL",{"data-svelte-h":!0}),r(Bi)!=="svelte-15k3fgy"&&(Bi.innerHTML=kd),Pa=n(t),h(Xi.$$.fragment,t),Ia=n(t),ji=o(t,"P",{"data-svelte-h":!0}),r(ji)!=="svelte-14yj5kr"&&(ji.textContent=xd),Ua=n(t),Gi=o(t,"UL",{"data-svelte-h":!0}),r(Gi)!=="svelte-1stsmlj"&&(Gi.innerHTML=$d),Fa=n(t),h(Oi.$$.fragment,t),Sa=n(t),Di=o(t,"UL",{"data-svelte-h":!0}),r(Di)!=="svelte-1ksbgxy"&&(Di.innerHTML=Td),za=n(t),h(Ji.$$.fragment,t),Ra=n(t),qi=o(t,"UL",{"data-svelte-h":!0}),r(qi)!=="svelte-1phzket"&&(qi.innerHTML=yd),Ba=n(t),h(Wi.$$.fragment,t),Xa=n(t),Yi=o(t,"UL",{"data-svelte-h":!0}),r(Yi)!=="svelte-1whjijd"&&(Yi.innerHTML=Ld),ja=n(t),h(Ki.$$.fragment,t),Ga=n(t),Qi=o(t,"UL",{"data-svelte-h":!0}),r(Qi)!=="svelte-1dzgmu6"&&(Qi.innerHTML=Md),Oa=n(t),h(Zi.$$.fragment,t),Da=n(t),te=o(t,"UL",{"data-svelte-h":!0}),r(te)!=="svelte-abrsee"&&(te.innerHTML=Ad),Ja=n(t),h(ie.$$.fragment,t),qa=n(t),ee=o(t,"UL",{"data-svelte-h":!0}),r(ee)!=="svelte-rnuh6y"&&(ee.innerHTML=Cd),Wa=n(t),h(le.$$.fragment,t),Ya=n(t),ae=o(t,"UL",{"data-svelte-h":!0}),r(ae)!=="svelte-7l2ez"&&(ae.innerHTML=Hd),Ka=n(t),h(ne.$$.fragment,t),Qa=n(t),oe=o(t,"P",{}),Nd(oe).forEach(e),this.h()},h(){Vd(p,"name","hf:doc:metadata"),Vd(p,"content",Xd)},m(t,i){zd(document.head,p),l(t,re,i),l(t,de,i),l(t,ge,i),s(u,t,i),l(t,he,i),s(w,t,i),l(t,se,i),l(t,v,i),l(t,fe,i),s(b,t,i),l(t,_e,i),l(t,k,i),l(t,me,i),s(x,t,i),l(t,ce,i),l(t,$,i),l(t,pe,i),s(T,t,i),l(t,ue,i),l(t,y,i),l(t,we,i),s(L,t,i),l(t,ve,i),l(t,M,i),l(t,be,i),s(A,t,i),l(t,ke,i),l(t,C,i),l(t,xe,i),s(H,t,i),l(t,$e,i),l(t,N,i),l(t,Te,i),s(V,t,i),l(t,ye,i),l(t,E,i),l(t,Le,i),s(P,t,i),l(t,Me,i),l(t,I,i),l(t,Ae,i),s(U,t,i),l(t,Ce,i),l(t,F,i),l(t,He,i),s(S,t,i),l(t,Ne,i),l(t,z,i),l(t,Ve,i),s(R,t,i),l(t,Ee,i),l(t,B,i),l(t,Pe,i),l(t,X,i),l(t,Ie,i),l(t,j,i),l(t,Ue,i),l(t,G,i),l(t,Fe,i),l(t,O,i),l(t,Se,i),s(D,t,i),l(t,ze,i),l(t,J,i),l(t,Re,i),s(q,t,i),l(t,Be,i),l(t,W,i),l(t,Xe,i),s(Y,t,i),l(t,je,i),l(t,K,i),l(t,Ge,i),s(Q,t,i),l(t,Oe,i),l(t,Z,i),l(t,De,i),s(tt,t,i),l(t,Je,i),l(t,it,i),l(t,qe,i),s(et,t,i),l(t,We,i),l(t,lt,i),l(t,Ye,i),l(t,at,i),l(t,Ke,i),s(nt,t,i),l(t,Qe,i),l(t,dt,i),l(t,Ze,i),s(ot,t,i),l(t,tl,i),l(t,rt,i),l(t,il,i),s(gt,t,i),l(t,el,i),l(t,ht,i),l(t,ll,i),s(st,t,i),l(t,al,i),l(t,ft,i),l(t,nl,i),s(_t,t,i),l(t,dl,i),l(t,mt,i),l(t,ol,i),l(t,ct,i),l(t,rl,i),s(pt,t,i),l(t,gl,i),l(t,ut,i),l(t,hl,i),l(t,wt,i),l(t,sl,i),s(vt,t,i),l(t,fl,i),l(t,bt,i),l(t,_l,i),l(t,kt,i),l(t,ml,i),l(t,xt,i),l(t,cl,i),l(t,$t,i),l(t,pl,i),s(Tt,t,i),l(t,ul,i),l(t,yt,i),l(t,wl,i),s(Lt,t,i),l(t,vl,i),l(t,Mt,i),l(t,bl,i),s(At,t,i),l(t,kl,i),l(t,Ct,i),l(t,xl,i),s(Ht,t,i),l(t,$l,i),l(t,Nt,i),l(t,Tl,i),s(Vt,t,i),l(t,yl,i),l(t,Et,i),l(t,Ll,i),s(Pt,t,i),l(t,Ml,i),l(t,It,i),l(t,Al,i),s(Ut,t,i),l(t,Cl,i),l(t,Ft,i),l(t,Hl,i),s(St,t,i),l(t,Nl,i),l(t,zt,i),l(t,Vl,i),s(Rt,t,i),l(t,El,i),l(t,Bt,i),l(t,Pl,i),s(Xt,t,i),l(t,Il,i),l(t,jt,i),l(t,Ul,i),s(Gt,t,i),l(t,Fl,i),l(t,Ot,i),l(t,Sl,i),l(t,Dt,i),l(t,zl,i),s(Jt,t,i),l(t,Rl,i),l(t,qt,i),l(t,Bl,i),s(Wt,t,i),l(t,Xl,i),l(t,Yt,i),l(t,jl,i),s(Kt,t,i),l(t,Gl,i),l(t,Qt,i),l(t,Ol,i),s(Zt,t,i),l(t,Dl,i),l(t,ti,i),l(t,Jl,i),s(ii,t,i),l(t,ql,i),l(t,ei,i),l(t,Wl,i),s(li,t,i),l(t,Yl,i),l(t,ai,i),l(t,Kl,i),s(ni,t,i),l(t,Ql,i),l(t,di,i),l(t,Zl,i),s(oi,t,i),l(t,ta,i),l(t,ri,i),l(t,ia,i),s(gi,t,i),l(t,ea,i),l(t,hi,i),l(t,la,i),s(si,t,i),l(t,aa,i),l(t,fi,i),l(t,na,i),l(t,_i,i),l(t,da,i),s(mi,t,i),l(t,oa,i),l(t,ci,i),l(t,ra,i),l(t,pi,i),l(t,ga,i),s(ui,t,i),l(t,ha,i),l(t,wi,i),l(t,sa,i),l(t,vi,i),l(t,fa,i),l(t,bi,i),l(t,_a,i),l(t,ki,i),l(t,ma,i),s(xi,t,i),l(t,ca,i),l(t,$i,i),l(t,pa,i),s(Ti,t,i),l(t,ua,i),l(t,yi,i),l(t,wa,i),s(Li,t,i),l(t,va,i),l(t,Mi,i),l(t,ba,i),s(Ai,t,i),l(t,ka,i),l(t,Ci,i),l(t,xa,i),s(Hi,t,i),l(t,$a,i),l(t,Ni,i),l(t,Ta,i),s(Vi,t,i),l(t,ya,i),l(t,Ei,i),l(t,La,i),s(Pi,t,i),l(t,Ma,i),l(t,Ii,i),l(t,Aa,i),s(Ui,t,i),l(t,Ca,i),l(t,Fi,i),l(t,Ha,i),s(Si,t,i),l(t,Na,i),l(t,zi,i),l(t,Va,i),s(Ri,t,i),l(t,Ea,i),l(t,Bi,i),l(t,Pa,i),s(Xi,t,i),l(t,Ia,i),l(t,ji,i),l(t,Ua,i),l(t,Gi,i),l(t,Fa,i),s(Oi,t,i),l(t,Sa,i),l(t,Di,i),l(t,za,i),s(Ji,t,i),l(t,Ra,i),l(t,qi,i),l(t,Ba,i),s(Wi,t,i),l(t,Xa,i),l(t,Yi,i),l(t,ja,i),s(Ki,t,i),l(t,Ga,i),l(t,Qi,i),l(t,Oa,i),s(Zi,t,i),l(t,Da,i),l(t,te,i),l(t,Ja,i),s(ie,t,i),l(t,qa,i),l(t,ee,i),l(t,Wa,i),s(le,t,i),l(t,Ya,i),l(t,ae,i),l(t,Ka,i),s(ne,t,i),l(t,Qa,i),l(t,oe,i),Za=!0},p:Pd,i(t){Za||(f(u.$$.fragment,t),f(w.$$.fragment,t),f(b.$$.fragment,t),f(x.$$.fragment,t),f(T.$$.fragment,t),f(L.$$.fragment,t),f(A.$$.fragment,t),f(H.$$.fragment,t),f(V.$$.fragment,t),f(P.$$.fragment,t),f(U.$$.fragment,t),f(S.$$.fragment,t),f(R.$$.fragment,t),f(D.$$.fragment,t),f(q.$$.fragment,t),f(Y.$$.fragment,t),f(Q.$$.fragment,t),f(tt.$$.fragment,t),f(et.$$.fragment,t),f(nt.$$.fragment,t),f(ot.$$.fragment,t),f(gt.$$.fragment,t),f(st.$$.fragment,t),f(_t.$$.fragment,t),f(pt.$$.fragment,t),f(vt.$$.fragment,t),f(Tt.$$.fragment,t),f(Lt.$$.fragment,t),f(At.$$.fragment,t),f(Ht.$$.fragment,t),f(Vt.$$.fragment,t),f(Pt.$$.fragment,t),f(Ut.$$.fragment,t),f(St.$$.fragment,t),f(Rt.$$.fragment,t),f(Xt.$$.fragment,t),f(Gt.$$.fragment,t),f(Jt.$$.fragment,t),f(Wt.$$.fragment,t),f(Kt.$$.fragment,t),f(Zt.$$.fragment,t),f(ii.$$.fragment,t),f(li.$$.fragment,t),f(ni.$$.fragment,t),f(oi.$$.fragment,t),f(gi.$$.fragment,t),f(si.$$.fragment,t),f(mi.$$.fragment,t),f(ui.$$.fragment,t),f(xi.$$.fragment,t),f(Ti.$$.fragment,t),f(Li.$$.fragment,t),f(Ai.$$.fragment,t),f(Hi.$$.fragment,t),f(Vi.$$.fragment,t),f(Pi.$$.fragment,t),f(Ui.$$.fragment,t),f(Si.$$.fragment,t),f(Ri.$$.fragment,t),f(Xi.$$.fragment,t),f(Oi.$$.fragment,t),f(Ji.$$.fragment,t),f(Wi.$$.fragment,t),f(Ki.$$.fragment,t),f(Zi.$$.fragment,t),f(ie.$$.fragment,t),f(le.$$.fragment,t),f(ne.$$.fragment,t),Za=!0)},o(t){_(u.$$.fragment,t),_(w.$$.fragment,t),_(b.$$.fragment,t),_(x.$$.fragment,t),_(T.$$.fragment,t),_(L.$$.fragment,t),_(A.$$.fragment,t),_(H.$$.fragment,t),_(V.$$.fragment,t),_(P.$$.fragment,t),_(U.$$.fragment,t),_(S.$$.fragment,t),_(R.$$.fragment,t),_(D.$$.fragment,t),_(q.$$.fragment,t),_(Y.$$.fragment,t),_(Q.$$.fragment,t),_(tt.$$.fragment,t),_(et.$$.fragment,t),_(nt.$$.fragment,t),_(ot.$$.fragment,t),_(gt.$$.fragment,t),_(st.$$.fragment,t),_(_t.$$.fragment,t),_(pt.$$.fragment,t),_(vt.$$.fragment,t),_(Tt.$$.fragment,t),_(Lt.$$.fragment,t),_(At.$$.fragment,t),_(Ht.$$.fragment,t),_(Vt.$$.fragment,t),_(Pt.$$.fragment,t),_(Ut.$$.fragment,t),_(St.$$.fragment,t),_(Rt.$$.fragment,t),_(Xt.$$.fragment,t),_(Gt.$$.fragment,t),_(Jt.$$.fragment,t),_(Wt.$$.fragment,t),_(Kt.$$.fragment,t),_(Zt.$$.fragment,t),_(ii.$$.fragment,t),_(li.$$.fragment,t),_(ni.$$.fragment,t),_(oi.$$.fragment,t),_(gi.$$.fragment,t),_(si.$$.fragment,t),_(mi.$$.fragment,t),_(ui.$$.fragment,t),_(xi.$$.fragment,t),_(Ti.$$.fragment,t),_(Li.$$.fragment,t),_(Ai.$$.fragment,t),_(Hi.$$.fragment,t),_(Vi.$$.fragment,t),_(Pi.$$.fragment,t),_(Ui.$$.fragment,t),_(Si.$$.fragment,t),_(Ri.$$.fragment,t),_(Xi.$$.fragment,t),_(Oi.$$.fragment,t),_(Ji.$$.fragment,t),_(Wi.$$.fragment,t),_(Ki.$$.fragment,t),_(Zi.$$.fragment,t),_(ie.$$.fragment,t),_(le.$$.fragment,t),_(ne.$$.fragment,t),Za=!1},d(t){t&&(e(re),e(de),e(ge),e(he),e(se),e(v),e(fe),e(_e),e(k),e(me),e(ce),e($),e(pe),e(ue),e(y),e(we),e(ve),e(M),e(be),e(ke),e(C),e(xe),e($e),e(N),e(Te),e(ye),e(E),e(Le),e(Me),e(I),e(Ae),e(Ce),e(F),e(He),e(Ne),e(z),e(Ve),e(Ee),e(B),e(Pe),e(X),e(Ie),e(j),e(Ue),e(G),e(Fe),e(O),e(Se),e(ze),e(J),e(Re),e(Be),e(W),e(Xe),e(je),e(K),e(Ge),e(Oe),e(Z),e(De),e(Je),e(it),e(qe),e(We),e(lt),e(Ye),e(at),e(Ke),e(Qe),e(dt),e(Ze),e(tl),e(rt),e(il),e(el),e(ht),e(ll),e(al),e(ft),e(nl),e(dl),e(mt),e(ol),e(ct),e(rl),e(gl),e(ut),e(hl),e(wt),e(sl),e(fl),e(bt),e(_l),e(kt),e(ml),e(xt),e(cl),e($t),e(pl),e(ul),e(yt),e(wl),e(vl),e(Mt),e(bl),e(kl),e(Ct),e(xl),e($l),e(Nt),e(Tl),e(yl),e(Et),e(Ll),e(Ml),e(It),e(Al),e(Cl),e(Ft),e(Hl),e(Nl),e(zt),e(Vl),e(El),e(Bt),e(Pl),e(Il),e(jt),e(Ul),e(Fl),e(Ot),e(Sl),e(Dt),e(zl),e(Rl),e(qt),e(Bl),e(Xl),e(Yt),e(jl),e(Gl),e(Qt),e(Ol),e(Dl),e(ti),e(Jl),e(ql),e(ei),e(Wl),e(Yl),e(ai),e(Kl),e(Ql),e(di),e(Zl),e(ta),e(ri),e(ia),e(ea),e(hi),e(la),e(aa),e(fi),e(na),e(_i),e(da),e(oa),e(ci),e(ra),e(pi),e(ga),e(ha),e(wi),e(sa),e(vi),e(fa),e(bi),e(_a),e(ki),e(ma),e(ca),e($i),e(pa),e(ua),e(yi),e(wa),e(va),e(Mi),e(ba),e(ka),e(Ci),e(xa),e($a),e(Ni),e(Ta),e(ya),e(Ei),e(La),e(Ma),e(Ii),e(Aa),e(Ca),e(Fi),e(Ha),e(Na),e(zi),e(Va),e(Ea),e(Bi),e(Pa),e(Ia),e(ji),e(Ua),e(Gi),e(Fa),e(Sa),e(Di),e(za),e(Ra),e(qi),e(Ba),e(Xa),e(Yi),e(ja),e(Ga),e(Qi),e(Oa),e(Da),e(te),e(Ja),e(qa),e(ee),e(Wa),e(Ya),e(ae),e(Ka),e(Qa),e(oe)),e(p),m(u,t),m(w,t),m(b,t),m(x,t),m(T,t),m(L,t),m(A,t),m(H,t),m(V,t),m(P,t),m(U,t),m(S,t),m(R,t),m(D,t),m(q,t),m(Y,t),m(Q,t),m(tt,t),m(et,t),m(nt,t),m(ot,t),m(gt,t),m(st,t),m(_t,t),m(pt,t),m(vt,t),m(Tt,t),m(Lt,t),m(At,t),m(Ht,t),m(Vt,t),m(Pt,t),m(Ut,t),m(St,t),m(Rt,t),m(Xt,t),m(Gt,t),m(Jt,t),m(Wt,t),m(Kt,t),m(Zt,t),m(ii,t),m(li,t),m(ni,t),m(oi,t),m(gi,t),m(si,t),m(mi,t),m(ui,t),m(xi,t),m(Ti,t),m(Li,t),m(Ai,t),m(Hi,t),m(Vi,t),m(Pi,t),m(Ui,t),m(Si,t),m(Ri,t),m(Xi,t),m(Oi,t),m(Ji,t),m(Wi,t),m(Ki,t),m(Zi,t),m(ie,t),m(le,t),m(ne,t)}}}const Xd='{"title":"Recent Changes","local":"recent-changes","sections":[{"title":"Aug 28, 2023","local":"aug-28-2023","sections":[],"depth":3},{"title":"Aug 25, 2023","local":"aug-25-2023","sections":[],"depth":3},{"title":"Aug 11, 2023","local":"aug-11-2023","sections":[],"depth":3},{"title":"Aug 3, 2023","local":"aug-3-2023","sections":[],"depth":3},{"title":"July 27, 2023","local":"july-27-2023","sections":[],"depth":3},{"title":"May 11, 2023","local":"may-11-2023","sections":[],"depth":3},{"title":"May 10, 2023","local":"may-10-2023","sections":[],"depth":3},{"title":"April 27, 2023","local":"april-27-2023","sections":[],"depth":3},{"title":"April 21, 2023","local":"april-21-2023","sections":[],"depth":3},{"title":"April 12, 2023","local":"april-12-2023","sections":[],"depth":3},{"title":"April 5, 2023","local":"april-5-2023","sections":[],"depth":3},{"title":"March 31, 2023","local":"march-31-2023","sections":[],"depth":3},{"title":"March 22, 2023","local":"march-22-2023","sections":[],"depth":3},{"title":"Feb 26, 2023","local":"feb-26-2023","sections":[],"depth":3},{"title":"Feb 20, 2023","local":"feb-20-2023","sections":[],"depth":3},{"title":"Feb 16, 2023","local":"feb-16-2023","sections":[],"depth":3},{"title":"Feb 7, 2023","local":"feb-7-2023","sections":[],"depth":3},{"title":"Jan 20, 2023","local":"jan-20-2023","sections":[],"depth":3},{"title":"Jan 11, 2023","local":"jan-11-2023","sections":[],"depth":3},{"title":"Jan 6, 2023","local":"jan-6-2023","sections":[],"depth":3},{"title":"Jan 5, 2023","local":"jan-5-2023","sections":[],"depth":3},{"title":"Dec 23, 2022 🎄☃","local":"dec-23-2022-","sections":[],"depth":3},{"title":"Dec 8, 2022","local":"dec-8-2022","sections":[],"depth":3},{"title":"Dec 6, 2022","local":"dec-6-2022","sections":[],"depth":3},{"title":"Dec 5, 2022","local":"dec-5-2022","sections":[],"depth":3},{"title":"Oct 15, 2022","local":"oct-15-2022","sections":[],"depth":3},{"title":"Oct 10, 2022","local":"oct-10-2022","sections":[],"depth":3},{"title":"Sept 23, 2022","local":"sept-23-2022","sections":[],"depth":3},{"title":"Sept 7, 2022","local":"sept-7-2022","sections":[],"depth":3},{"title":"Aug 29, 2022","local":"aug-29-2022","sections":[],"depth":3},{"title":"Aug 26, 2022","local":"aug-26-2022","sections":[],"depth":3},{"title":"Aug 15, 2022","local":"aug-15-2022","sections":[],"depth":3},{"title":"Aug 5, 2022","local":"aug-5-2022","sections":[],"depth":3},{"title":"July 28, 2022","local":"july-28-2022","sections":[],"depth":3},{"title":"July 27, 2022","local":"july-27-2022","sections":[],"depth":3},{"title":"July 8, 2022","local":"july-8-2022","sections":[],"depth":3},{"title":"May 13, 2022","local":"may-13-2022","sections":[],"depth":3},{"title":"May 2, 2022","local":"may-2-2022","sections":[],"depth":3},{"title":"April 22, 2022","local":"april-22-2022","sections":[],"depth":3},{"title":"March 23, 2022","local":"march-23-2022","sections":[],"depth":3},{"title":"March 21, 2022","local":"march-21-2022","sections":[],"depth":3},{"title":"Feb 2, 2022","local":"feb-2-2022","sections":[],"depth":3},{"title":"Jan 14, 2022","local":"jan-14-2022","sections":[],"depth":3},{"title":"Jan 5, 2023","local":"jan-5-2023","sections":[],"depth":3},{"title":"Dec 23, 2022 🎄☃","local":"dec-23-2022-","sections":[],"depth":3},{"title":"Dec 8, 2022","local":"dec-8-2022","sections":[],"depth":3},{"title":"Dec 6, 2022","local":"dec-6-2022","sections":[],"depth":3},{"title":"Dec 5, 2022","local":"dec-5-2022","sections":[],"depth":3},{"title":"Oct 15, 2022","local":"oct-15-2022","sections":[],"depth":3},{"title":"Oct 10, 2022","local":"oct-10-2022","sections":[],"depth":3},{"title":"Sept 23, 2022","local":"sept-23-2022","sections":[],"depth":3},{"title":"Sept 7, 2022","local":"sept-7-2022","sections":[],"depth":3},{"title":"Aug 29, 2022","local":"aug-29-2022","sections":[],"depth":3},{"title":"Aug 26, 2022","local":"aug-26-2022","sections":[],"depth":3},{"title":"Aug 15, 2022","local":"aug-15-2022","sections":[],"depth":3},{"title":"Aug 5, 2022","local":"aug-5-2022","sections":[],"depth":3},{"title":"July 28, 2022","local":"july-28-2022","sections":[],"depth":3},{"title":"July 27, 2022","local":"july-27-2022","sections":[],"depth":3},{"title":"July 8, 2022","local":"july-8-2022","sections":[],"depth":3},{"title":"May 13, 2022","local":"may-13-2022","sections":[],"depth":3},{"title":"May 2, 2022","local":"may-2-2022","sections":[],"depth":3},{"title":"April 22, 2022","local":"april-22-2022","sections":[],"depth":3},{"title":"March 23, 2022","local":"march-23-2022","sections":[],"depth":3},{"title":"March 21, 2022","local":"march-21-2022","sections":[],"depth":3},{"title":"Feb 2, 2022","local":"feb-2-2022","sections":[],"depth":3},{"title":"Jan 14, 2022","local":"jan-14-2022","sections":[],"depth":3}],"depth":1}';function jd(tn){return Id(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Jd extends Ud{constructor(p){super(),Fd(this,p,jd,Bd,Ed,{})}}export{Jd as component};
